/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "igniteui-webcomponents-charts";
import { typeCast, Number_$type, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { PlatformConstants } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicMapSeriesHost = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHost extends Series {
        qg() {
            super.qg();
            if (this.w2 != null) {
                this.w2.qg();
            }
        }
        constructor() {
            super();
            this.w0 = null;
            this.w2 = this.w1();
        }
        get_fc() {
            return true;
        }
        kq(a, b) {
            let c = this.nd(b);
            if (c == "LatitudeMemberPath") {
                c = "YMemberPath";
            }
            if (c == "LongitudeMemberPath") {
                c = "XMemberPath";
            }
            return this.w2.kq(a, c);
        }
        md(a) {
            let b = this.nd(a);
            if (b == "LatitudeMemberPath") {
                b = "YMemberPath";
            }
            if (b == "LongitudeMemberPath") {
                b = "XMemberPath";
            }
            return this.w2.md(b);
        }
        get_ki() {
            return this.k0(this.w2);
        }
        set_ki(a) {
            this.oz(this.w2, a);
        }
        ec(a, b, c, d, e) {
            return this.w2.ec(a, b, c, d, e);
        }
        ai() {
            return this.w2.ai();
        }
        bp() {
            return this.w2;
        }
        get w2() {
            return this.w0;
        }
        set w2(a) {
            let b = this.w0;
            let c = this.w2 != a;
            if (c) {
                this.w0 = a;
                this.w7(b, this.w0);
            }
        }
        get_hasMarkers() {
            return this.w2.hasMarkers;
        }
        w7(a, b) {
            if (this.w0 != null) {
                let hostedSeries_ = this.w0;
                hostedSeries_.externalObject = TypeRegistrar.createFromInternal(hostedSeries_, PlatformConstants.Prefix, PlatformConstants.Postfix);
                hostedSeries_.externalObject._implementation = hostedSeries_;
            }
            this.pf(this.w2);
            this.w3.b9();
            if (a != null) {
                let c = (a);
                this.r3(c, null);
            }
            if (b != null) {
                let d = (b);
                this.r3(d, this);
            }
        }
        dh(a, b, c) {
            return this.dj(this.w2, a, b, c);
        }
        di(a, b, c) {
            return this.dk(this.w2, a, b, c);
        }
        kn(a) {
            return this.kw(this.w2, a);
        }
        ka(a, b) {
            return this.w2.ka(a, b);
        }
        j8(a, b) {
            return this.w2.j8(a, b);
        }
        i5(a, b, c) {
            return this.w2.i5(a, b, c);
        }
        we(a, b, c) {
            return this.w2.we(a, b, c);
        }
        wp(a) {
            return this.w2.wp(a);
        }
        ao(a) {
            return this.w2.ao(a);
        }
        wq(a) {
            return this.w2.wq(a);
        }
        ap(a) {
            return this.w2.ap(a);
        }
        wr(a) {
            return this.w2.wr(a);
        }
        ws(a) {
            return this.w2.ws(a);
        }
        i1(a, b, c) {
            return this.w2.i1(a, b, c);
        }
        wa(a, b, c) {
            return this.w2.wa(a, b, c);
        }
        i3(a, b, c) {
            return this.i5(a, b, c);
        }
        wc(a, b, c) {
            return this.w2.wc(a, b, c);
        }
        wf(a, b, c) {
            return this.w2.wf(a, b, c);
        }
        i6(a, b, c) {
            return this.w2.i6(a, b, c);
        }
        wb(a, b, c) {
            return this.w2.wb(a, b, c);
        }
        i2(a, b, c) {
            return this.w2.i2(a, b, c);
        }
        wd(a, b, c) {
            return this.w2.wd(a, b, c);
        }
        i4(a, b, c) {
            return this.w2.i4(a, b, c);
        }
        j4(a) {
            return this.w2.j4(a);
        }
        iw() {
            return this.w2.iw();
        }
        is(a) {
            return this.w2.is(a);
        }
        ko(a) {
            return this.w2.ko(a);
        }
        ct() {
            return new HostSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.w3 = typeCast(HostSeriesView.$, a);
        }
        get w4() {
            return this.c(GeographicMapSeriesHost.w9);
        }
        set w4(a) {
            this.h(GeographicMapSeriesHost.w9, a);
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.w2.dc = this.dc;
                    if (c != null) {
                        c.q5(this.w2);
                    }
                    if (d != null) {
                        this.dc.m9(this.w2);
                    }
                    this.w2.rd(this.wu);
                    this.w2.index = this.index;
                    this.p0(this.w2);
                    this.kg = this.w2.kg;
                    let e = typeCast(SeriesViewer.$, c);
                    if (e != null) {
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.w8));
                    }
                    if (this.dc != null) {
                        let f = this.dc;
                        f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, runOn(this, this.w8));
                    }
                    this.w6();
                    break;
                case "SyncLink":
                    this.w2.c4 = this.c4;
                    break;
                case "VisibleFromScale":
                    this.w6();
                    break;
                case "Index":
                    this.w2.index = this.index;
                    break;
                case "ItemsSource":
                    this.w3.ca();
                    break;
                case "Resolution":
                    this.w3.ch();
                    break;
                case "TransitionDuration":
                    this.w3.ck();
                    break;
                case "Opacity":
                    this.w3.ce();
                    break;
                case "Visibility":
                    let hs_ = this.w2;
                    let v_ = this._visibility;
                    hs_.visibility = v_;
                    break;
                case "MouseOverEnabled":
                    this.w2.f8 = this.f8;
                    break;
                case "ExpectFunctions":
                    this.w2.expectFunctions = this.expectFunctions;
                    break;
                case "Thickness":
                    this.w3.cj();
                    break;
                case "Brush":
                    this.w3.b8();
                    break;
                case "Outline":
                    this.w3.cg();
                    break;
                case "ActualBrush":
                    this.w3.b5();
                    break;
                case "ActualOutline":
                    this.w3.b6();
                    break;
                case "MarkerFillOpacity":
                    if (!isNaN_(this.jg)) {
                        this.w3.cd();
                    }
                    break;
                case "AreaFillOpacity":
                    if (!isNaN_(this.ik)) {
                        this.w3.b7();
                    }
                    break;
                case "OutlineMode":
                    this.w3.cf();
                    break;
                case "ShowDefaultTooltip":
                    this.w3.ci();
                    break;
                case "Title":
                    this.w2.title = this.title;
                    break;
                case "LegendItemBadgeMode":
                    this.w3.cb();
                    break;
                case "LegendItemBadgeShape":
                    this.w3.cc();
                    break;
                case "Legend":
                    this.w2.legend = this.legend;
                    this.cw.ay();
                    break;
            }
        }
        w6() {
            if (this.dc == null || this.w2 == null) {
                return;
            }
            if (!isNaN_(this.w4)) {
                if (this.dc.v5.width > this.w4) {
                    let hs_ = this.w2;
                    let v_ = 1;
                    hs_.visibility = v_;
                }
                else {
                    let hs2_ = this.w2;
                    let v2_ = 0;
                    hs2_.visibility = v2_;
                }
            }
        }
        w8(a, b) {
            this.w6();
        }
        rs(a) {
            super.rs(a);
            if (this.w2 != null) {
                this.w2.rs(a);
            }
        }
        q5(a) {
            super.q5(a);
            if (this.w2 != null) {
                this.w2.qn();
            }
        }
        rr(a, b, c, d, e) {
            if (this.w2 != null) {
                this.w2.rr(a, b, c, d, e);
            }
        }
        a2(a, b) {
            return this.w2.a2(a, b);
        }
        se() {
            super.se();
            this.w2.se();
        }
        get_coercionMethods() {
            return this._coercionMethods;
        }
        set_coercionMethods(a) {
            this._coercionMethods = a;
            this.w2.coercionMethods = a;
        }
        pz(a) {
            super.pz(a);
            if (this.w2 != null) {
                let b = this.w2.km();
                this.o8(a, b);
            }
        }
    }
    GeographicMapSeriesHost.$t = /*@__PURE__*/ markType(GeographicMapSeriesHost, 'GeographicMapSeriesHost', Series.$);
    GeographicMapSeriesHost.w9 = /*@__PURE__*/ DependencyProperty.i("VisibleFromScale", Number_$type, GeographicMapSeriesHost.$, /*@__PURE__*/ new PropertyMetadata(2, 1, (a, b) => {
        let c = a;
        c.raisePropertyChanged("VisibleFromScale", b.oldValue, b.newValue);
    }));
    return GeographicMapSeriesHost;
})();
/**
 * @hidden
 */
export let HostSeriesView = /*@__PURE__*/ (() => {
    class HostSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b4 = a;
        }
        aw(a, b) {
            super.aw(a, b);
        }
        b9() {
            this.b4.legendItemVisibility = 1;
            this.b4.w2.legendItemVisibility = 0;
            this.b4.w2.itemsSource = this.b4.itemsSource;
            this.b4.w2.index = this.b4.index;
            this.b4.w2.vh = this.b4.vh;
            this.b4.w2.vx = this.b4.vh;
            this.b4.w2.cj = this.b4.cj;
            this.b4.w2.jj = this.b4.jj;
            this.b4.w2.kd = this.b4.kd;
            this.b4.w2._opacity = this.b4._opacity;
            this.b4.w2.jp = this.b4.jp;
            this.b4.w2.ik = this.b4.ik;
            this.b4.w2.jg = this.b4.jg;
            this.b4.w2.gp = this.b4.gp;
            this.b4.w2.legendItemBadgeShape = this.b4.legendItemBadgeShape;
            this.b4.w2.be = this.b4.be;
        }
        ca() {
            this.b4.w2.itemsSource = this.b4.itemsSource;
        }
        ch() {
            this.b4.w2.jj = this.b4.jj;
        }
        ck() {
            this.b4.w2.kd = this.b4.kd;
        }
        ce() {
            this.b4.w2._opacity = this.b4._opacity;
        }
        cj() {
            this.b4.w2.jp = this.b4.jp;
        }
        b8() {
            this.b4.w2.vh = this.b4.vh;
        }
        cg() {
            this.b4.w2.vx = this.b4.vx;
        }
        b5() {
            this.b4.w2.vh = this.b4.vb;
        }
        b6() {
            this.b4.w2.vx = this.b4.vf;
        }
        cb() {
            this.b4.w2.be = this.b4.be;
        }
        cc() {
            this.b4.w2.legendItemBadgeShape = this.b4.legendItemBadgeShape;
        }
        b7() {
            this.b4.w2.ik = this.b4.ik;
        }
        cd() {
            this.b4.w2.jg = this.b4.jg;
        }
        cf() {
            this.b4.w2.cj = this.b4.cj;
        }
        ci() {
            this.b4.w2.gp = this.b4.gp;
        }
    }
    HostSeriesView.$t = /*@__PURE__*/ markType(HostSeriesView, 'HostSeriesView', SeriesView.$);
    return HostSeriesView;
})();
