/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { BubbleSeries } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { SizeScale } from "igniteui-webcomponents-charts";
import { BrushScale } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicProportionalSymbolSeriesView = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cl = null;
            this.cl = a;
        }
        ax() {
            super.ax();
            if (!this.r) {
            }
        }
        b9() {
            super.b9();
            let a = this.cl.w2;
            a.aav = this.cl.y1;
            a.aa3 = this.cl.yz;
            a.xc = this.cl.xc;
            a.x4 = this.cl.xs;
            a.xl = this.cl.xd;
            a.ac5 = this.cl.yl;
            a.adv = this.cl.y6;
            a.acu = this.cl.yd;
            a.adl = this.cl.yx;
            a.adg = this.cl.yp;
            a.acr = this.cl.ya;
            a.ac3 = this.cl.yh;
            a.ac4 = this.cl.yk;
            a.ada = this.cl.yn;
            a.ac9 = this.cl.ym;
        }
        cu() {
            this.cl.w2.aav = this.cl.y1;
        }
        ct() {
            this.cl.w2.aa3 = this.cl.yz;
        }
        cz() {
            this.cl.w2.xc = this.cl.xc;
        }
        cx() {
            this.cl.w2.x4 = this.cl.xs;
        }
        cy() {
            this.cl.w2.xl = this.cl.xd;
        }
        c0() {
            this.cl.w2.aab = this.cl.xe;
        }
        c2() {
            this.cl.w2.xAxis = this.cl.dc.wv;
        }
        c3() {
            this.cl.w2.yAxis = this.cl.dc.wx;
        }
        c1() {
            let a = this.cl.w2;
            if (this.cl.dc == null) {
                a.xAxis = null;
                a.yAxis = null;
                return;
            }
            a.xAxis = this.cl.dc.wv;
            a.yAxis = this.cl.dc.wx;
        }
        cv() {
            this.cl.w2.yl = this.cl.x6;
        }
        cw() {
            this.cl.w2.ym = this.cl.x7;
        }
        c4() {
            this.cl.w2.adv = this.cl.y6;
        }
        c5() {
            this.cl.w2.acu = this.cl.yd;
            this.cl.w2.ac5 = this.cl.yl;
        }
        cp() {
            this.cl.w2.adl = this.cl.yx;
        }
        cn() {
            this.cl.w2.acr = this.cl.ya;
            this.cl.w2.ac3 = this.cl.yh;
            this.cl.w2.ac4 = this.cl.yk;
            this.cl.w2.ada = this.cl.yn;
            this.cl.w2.ac9 = this.cl.ym;
        }
        cm() {
            this.cl.w2.adg = this.cl.yp;
        }
        c6() {
            this.cl.w2.ac5 = this.cl.yl;
        }
        co() {
            this.cl.w2.ac3 = this.cl.yh;
        }
        cs() {
            this.cl.w2.ac4 = this.cl.yk;
        }
        cr() {
            this.cl.w2.ada = this.cl.yn;
        }
        cq() {
            this.cl.w2.ac9 = this.cl.ym;
        }
    }
    GeographicProportionalSymbolSeriesView.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesView, 'GeographicProportionalSymbolSeriesView', HostSeriesView.$);
    return GeographicProportionalSymbolSeriesView;
})();
/**
 * @hidden
 */
export let GeographicProportionalSymbolSeries = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeries extends GeographicMarkerSeries {
        bk() {
            return new GeographicProportionalSymbolSeries();
        }
        get_ej() {
            return true;
        }
        constructor() {
            super();
            this.yb = null;
            this.yg = false;
            this.yf = false;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ab = GeographicProportionalSymbolSeries.$;
        }
        ct() {
            return new GeographicProportionalSymbolSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.ye = a;
        }
        jl() {
            return 0.7;
        }
        w1() {
            return new BubbleSeries();
        }
        get_fe() {
            return true;
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.ye.c1();
                    break;
                case GeographicProportionalSymbolSeries.$$p[9]:
                    this.ye.cu();
                    break;
                case GeographicProportionalSymbolSeries.$$p[8]:
                    this.ye.ct();
                    break;
                case "XAxis":
                    this.ye.c2();
                    break;
                case "YAxis":
                    this.ye.c3();
                    break;
                case GeographicProportionalSymbolSeries.$$p[13]:
                    this.ye.c4();
                    break;
                case GeographicProportionalSymbolSeries.$$p[14]:
                    this.ye.c5();
                    break;
                case GeographicProportionalSymbolSeries.$$p[15]:
                    this.ye.c6();
                    break;
                case GeographicProportionalSymbolSeries.$$p[7]:
                    this.ye.cp();
                    break;
                case GeographicProportionalSymbolSeries.$$p[0]:
                    this.ye.cm();
                    break;
                case GeographicProportionalSymbolSeries.$$p[1]:
                    this.ye.cn();
                    break;
                case GeographicProportionalSymbolSeries.$$p[2]:
                    this.ye.co();
                    break;
                case GeographicProportionalSymbolSeries.$$p[12]:
                    this.ye.cs();
                    break;
                case GeographicProportionalSymbolSeries.$$p[11]:
                    this.ye.cr();
                    break;
                case GeographicProportionalSymbolSeries.$$p[10]:
                    this.ye.cq();
                    break;
                case GeographicProportionalSymbolSeries.$$p[4]:
                    this.w2.zr = this.yj;
                    this.yg = this.yj;
                    if (this.yj) {
                        let e = this.w2;
                        e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.zb));
                    }
                    else {
                        let f = this.w2;
                        f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.zb));
                    }
                    break;
                case GeographicProportionalSymbolSeries.$$p[3]:
                    this.w2.zq = this.yi;
                    this.yf = this.yi;
                    if (this.yj) {
                        let g = this.w2;
                        g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.za));
                    }
                    else {
                        let h = this.w2;
                        h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.za));
                    }
                    break;
                case GeographicProportionalSymbolSeries.$$p[5]:
                    this.w2.za = this.yc;
                    break;
                case GeographicProportionalSymbolSeries.$$p[6]:
                    this.w2.aaa = this.yo;
                    break;
            }
        }
        zb(a, b) {
            if (this.assigningScatterStyle != null) {
                this.assigningScatterStyle(this, b);
            }
        }
        za(a, b) {
            if (this.assigningScatterMarkerStyle != null) {
                this.assigningScatterMarkerStyle(this, b);
            }
        }
    }
    GeographicProportionalSymbolSeries.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeries, 'GeographicProportionalSymbolSeries', GeographicMarkerSeries.$);
    GeographicProportionalSymbolSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicProportionalSymbolSeries, 'raisePropertyChanged', ['FillMemberPath:yp:zc', [2], 'FillScale:ya:zd', [BrushScale.$], 'FillScaleUseGlobalValues:yh:ze', [0, false], 'IsCustomScatterMarkerStyleAllowed:yi:zf', [0, false], 'IsCustomScatterStyleAllowed:yj:zg', [0, false], 'ItemSearchMode:yc:zh', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:yo:zi', [1, 10000], 'LabelMemberPath:yx:zj', [2], 'LatitudeMemberPath:yz:zk', [2, null], 'LongitudeMemberPath:y1:zl', [2, null], 'MarkerBrushBrightness:ym:zm', [1, NaN], 'MarkerOutlineBrightness:yn:zn', [1, NaN], 'MarkerOutlineUsesFillScale:yk:zo', [0, false], 'RadiusMemberPath:y6:zp', [2, null], 'RadiusScale:yd:zq', [SizeScale.$], 'RadiusScaleUseGlobalValues:yl:zr', [0, false]]);
    return GeographicProportionalSymbolSeries;
})();
