/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicShapeSeriesBaseView } from "./GeographicShapeSeriesBaseView";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { Brush } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { MarkerType_$type } from "igniteui-webcomponents-charts";
import { MarkerFillMode_$type } from "igniteui-webcomponents-charts";
import { ScatterPolygonSeries } from "igniteui-webcomponents-charts";
import { markType, runOn, delegateCombine, typeCast, enumGetBox, markDep } from "igniteui-webcomponents-core";
import { StyleSelector } from "igniteui-webcomponents-charts";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { Style } from "igniteui-webcomponents-core";
import { MarkerOutlineMode_$type } from "igniteui-webcomponents-charts";
import { DataTemplate } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicShapeSeriesView = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesView extends GeographicShapeSeriesBaseView {
        constructor(a) {
            super(a);
            this.cp = null;
            this.cp = a;
            if (!this.r) {
                this.cp.x1 = "points";
            }
        }
        ax() {
            super.ax();
            if (!this.r) {
                this.cp.zo = Defaults.aj;
                this.cp.jp = Defaults.p;
                this.cp.yn = Defaults.o;
                this.cp.yk = Defaults.d;
                this.cp.yi = Defaults.a;
            }
        }
        b9() {
            super.b9();
            this.cp.w2.abv = this.cp.zq;
            this.cp.w2.aao = this.cp.yl;
            this.cp.w2.aba = this.cp.y6;
            this.cp.w2.aar = this.cp.yn;
            this.cp.w2.aaa = this.cp.yh;
        }
        cu() {
            this.cp.w2.aba = this.cp.y6;
        }
        cw() {
            this.cp.w2.aar = this.cp.yn;
        }
        cr() {
            this.cp.w2.aaa = this.cp.yh;
        }
        cv() {
            this.cp.w2.aaj = this.cp.yk;
        }
        cq() {
            this.cp.w2.abr = this.cp.zn;
        }
        cs() {
            this.cp.w2.abs = this.cp.zo;
        }
        ct() {
            this.cp.w2.abu = this.cp.zp;
        }
        cx() {
            this.cp.w2.aao = this.cp.yl;
        }
        cy() {
            this.cp.w2.abv = this.cp.zq;
        }
    }
    GeographicShapeSeriesView.$t = /*@__PURE__*/ markType(GeographicShapeSeriesView, 'GeographicShapeSeriesView', GeographicShapeSeriesBaseView.$);
    return GeographicShapeSeriesView;
})();
/**
 * @hidden
 */
export let GeographicShapeSeries = /*@__PURE__*/ (() => {
    class GeographicShapeSeries extends GeographicShapeSeriesBase {
        bk() {
            return new GeographicShapeSeries();
        }
        get_fq() {
            return true;
        }
        constructor() {
            super();
            this.styleShape = null;
            this.ab = GeographicShapeSeries.$;
        }
        ct() {
            return new GeographicShapeSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.ym = a;
        }
        w1() {
            let a = new ScatterPolygonSeries();
            a.styleShape = delegateCombine(a.styleShape, runOn(this, this.y3));
            a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.y4));
            return a;
        }
        y3(a, b) {
            if (this.styleShape != null) {
                this.styleShape(this, b);
            }
        }
        y4(a, b) {
            let c = typeCast(ScatterPolygonSeries.$, this.w2);
            if (c == null) {
                return;
            }
        }
        io() {
            return this.yn;
        }
        vn() {
            return this.zl;
        }
        vo() {
            return this.zm;
        }
        s1() {
            return this.y5;
        }
        ma() {
            let a = typeCast(ScatterPolygonSeries.$, this.w2);
            if (a == null) {
                return "Unknown";
            }
            return a.ma();
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case GeographicShapeSeries.$$p[6]:
                    this.w2.aah = this.yj;
                    break;
                case GeographicShapeSeries.$$p[5]:
                    this.w2.aad = this.yi;
                    break;
                case GeographicShapeSeries.$$p[9]:
                    this.ym.cu();
                    break;
                case GeographicShapeSeries.$$p[10]:
                    this.ym.cw();
                    break;
                case GeographicShapeSeries.$$p[4]:
                    this.ym.cr();
                    break;
                case GeographicShapeSeries.$$p[11]:
                    this.ym.cv();
                    break;
                case GeographicShapeSeries.$$p[3]:
                    this.ym.cq();
                    break;
                case GeographicShapeSeries.$$p[7]:
                    this.ym.cs();
                    break;
                case GeographicShapeSeries.$$p[8]:
                    this.ym.ct();
                    break;
                case GeographicShapeSeries.$$p[13]:
                    this.ym.cx();
                    break;
                case GeographicShapeSeries.$$p[12]:
                    this.ym.cy();
                    break;
            }
        }
        jl() {
            return 0.7;
        }
    }
    GeographicShapeSeries.$t = /*@__PURE__*/ markType(GeographicShapeSeries, 'GeographicShapeSeries', GeographicShapeSeriesBase.$);
    GeographicShapeSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeries, 'raisePropertyChanged', ['ActualMarkerBrush:zl:y7', [Brush.$], 'ActualMarkerOutline:zm:y8', [Brush.$], 'ActualMarkerTemplate:y5:y9', [DataTemplate.$, null], 'MarkerBrush:zn:za', [Brush.$], 'MarkerCollisionAvoidance:yh:zb', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:yi:zc', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:yj:zd', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:zo:ze', [Brush.$], 'MarkerStyle:zp:zf', [Style.$], 'MarkerTemplate:y6:zg', [DataTemplate.$, null], 'MarkerThickness:yn:zh', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:yk:zi', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, 2)], 'ShapeStyle:zq:zj', [Style.$, null], 'ShapeStyleSelector:yl:zk', [StyleSelector.$, null]]);
    return GeographicShapeSeries;
})();
