/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "igniteui-webcomponents-charts";
import { typeCast, Number_$type, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { PlatformConstants } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicMapSeriesHost = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapSeriesHost, _super);
    function GeographicMapSeriesHost() {
        var _this = _super.call(this) || this;
        _this.w0 = null;
        _this.w2 = _this.w1();
        return _this;
    }
    GeographicMapSeriesHost.prototype.qg = function () {
        _super.prototype.qg.call(this);
        if (this.w2 != null) {
            this.w2.qg();
        }
    };
    GeographicMapSeriesHost.prototype.get_fc = function () {
        return true;
    };
    GeographicMapSeriesHost.prototype.kq = function (a, b) {
        var c = this.nd(b);
        if (c == "LatitudeMemberPath") {
            c = "YMemberPath";
        }
        if (c == "LongitudeMemberPath") {
            c = "XMemberPath";
        }
        return this.w2.kq(a, c);
    };
    GeographicMapSeriesHost.prototype.md = function (a) {
        var b = this.nd(a);
        if (b == "LatitudeMemberPath") {
            b = "YMemberPath";
        }
        if (b == "LongitudeMemberPath") {
            b = "XMemberPath";
        }
        return this.w2.md(b);
    };
    GeographicMapSeriesHost.prototype.get_ki = function () {
        return this.k0(this.w2);
    };
    GeographicMapSeriesHost.prototype.set_ki = function (a) {
        this.oz(this.w2, a);
    };
    GeographicMapSeriesHost.prototype.ec = function (a, b, c, d, e) {
        return this.w2.ec(a, b, c, d, e);
    };
    GeographicMapSeriesHost.prototype.ai = function () {
        return this.w2.ai();
    };
    GeographicMapSeriesHost.prototype.bp = function () {
        return this.w2;
    };
    Object.defineProperty(GeographicMapSeriesHost.prototype, "w2", {
        get: function () {
            return this.w0;
        },
        set: function (a) {
            var b = this.w0;
            var c = this.w2 != a;
            if (c) {
                this.w0 = a;
                this.w7(b, this.w0);
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapSeriesHost.prototype.get_hasMarkers = function () {
        return this.w2.hasMarkers;
    };
    GeographicMapSeriesHost.prototype.w7 = function (a, b) {
        if (this.w0 != null) {
            var hostedSeries_ = this.w0;
            hostedSeries_.externalObject = TypeRegistrar.createFromInternal(hostedSeries_, PlatformConstants.Prefix, PlatformConstants.Postfix);
            hostedSeries_.externalObject._implementation = hostedSeries_;
        }
        this.pf(this.w2);
        this.w3.b9();
        if (a != null) {
            var c = (a);
            this.r3(c, null);
        }
        if (b != null) {
            var d = (b);
            this.r3(d, this);
        }
    };
    GeographicMapSeriesHost.prototype.dh = function (a, b, c) {
        return this.dj(this.w2, a, b, c);
    };
    GeographicMapSeriesHost.prototype.di = function (a, b, c) {
        return this.dk(this.w2, a, b, c);
    };
    GeographicMapSeriesHost.prototype.kn = function (a) {
        return this.kw(this.w2, a);
    };
    GeographicMapSeriesHost.prototype.ka = function (a, b) {
        return this.w2.ka(a, b);
    };
    GeographicMapSeriesHost.prototype.j8 = function (a, b) {
        return this.w2.j8(a, b);
    };
    GeographicMapSeriesHost.prototype.i5 = function (a, b, c) {
        return this.w2.i5(a, b, c);
    };
    GeographicMapSeriesHost.prototype.we = function (a, b, c) {
        return this.w2.we(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wp = function (a) {
        return this.w2.wp(a);
    };
    GeographicMapSeriesHost.prototype.ao = function (a) {
        return this.w2.ao(a);
    };
    GeographicMapSeriesHost.prototype.wq = function (a) {
        return this.w2.wq(a);
    };
    GeographicMapSeriesHost.prototype.ap = function (a) {
        return this.w2.ap(a);
    };
    GeographicMapSeriesHost.prototype.wr = function (a) {
        return this.w2.wr(a);
    };
    GeographicMapSeriesHost.prototype.ws = function (a) {
        return this.w2.ws(a);
    };
    GeographicMapSeriesHost.prototype.i1 = function (a, b, c) {
        return this.w2.i1(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wa = function (a, b, c) {
        return this.w2.wa(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i3 = function (a, b, c) {
        return this.i5(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wc = function (a, b, c) {
        return this.w2.wc(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wf = function (a, b, c) {
        return this.w2.wf(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i6 = function (a, b, c) {
        return this.w2.i6(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wb = function (a, b, c) {
        return this.w2.wb(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i2 = function (a, b, c) {
        return this.w2.i2(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wd = function (a, b, c) {
        return this.w2.wd(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i4 = function (a, b, c) {
        return this.w2.i4(a, b, c);
    };
    GeographicMapSeriesHost.prototype.j4 = function (a) {
        return this.w2.j4(a);
    };
    GeographicMapSeriesHost.prototype.iw = function () {
        return this.w2.iw();
    };
    GeographicMapSeriesHost.prototype.is = function (a) {
        return this.w2.is(a);
    };
    GeographicMapSeriesHost.prototype.ko = function (a) {
        return this.w2.ko(a);
    };
    GeographicMapSeriesHost.prototype.ct = function () {
        return new HostSeriesView(this);
    };
    GeographicMapSeriesHost.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.w3 = typeCast(HostSeriesView.$, a);
    };
    Object.defineProperty(GeographicMapSeriesHost.prototype, "w4", {
        get: function () {
            return this.c(GeographicMapSeriesHost.w9);
        },
        set: function (a) {
            this.h(GeographicMapSeriesHost.w9, a);
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapSeriesHost.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.w2.dc = this.dc;
                if (c != null) {
                    c.q5(this.w2);
                }
                if (d != null) {
                    this.dc.m9(this.w2);
                }
                this.w2.rd(this.wu);
                this.w2.index = this.index;
                this.p0(this.w2);
                this.kg = this.w2.kg;
                var e = typeCast(SeriesViewer.$, c);
                if (e != null) {
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.w8));
                }
                if (this.dc != null) {
                    var f = this.dc;
                    f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, runOn(this, this.w8));
                }
                this.w6();
                break;
            case "SyncLink":
                this.w2.c4 = this.c4;
                break;
            case "VisibleFromScale":
                this.w6();
                break;
            case "Index":
                this.w2.index = this.index;
                break;
            case "ItemsSource":
                this.w3.ca();
                break;
            case "Resolution":
                this.w3.ch();
                break;
            case "TransitionDuration":
                this.w3.ck();
                break;
            case "Opacity":
                this.w3.ce();
                break;
            case "Visibility":
                var hs_ = this.w2;
                var v_ = this._visibility;
                hs_.visibility = v_;
                break;
            case "MouseOverEnabled":
                this.w2.f8 = this.f8;
                break;
            case "ExpectFunctions":
                this.w2.expectFunctions = this.expectFunctions;
                break;
            case "Thickness":
                this.w3.cj();
                break;
            case "Brush":
                this.w3.b8();
                break;
            case "Outline":
                this.w3.cg();
                break;
            case "ActualBrush":
                this.w3.b5();
                break;
            case "ActualOutline":
                this.w3.b6();
                break;
            case "MarkerFillOpacity":
                if (!isNaN_(this.jg)) {
                    this.w3.cd();
                }
                break;
            case "AreaFillOpacity":
                if (!isNaN_(this.ik)) {
                    this.w3.b7();
                }
                break;
            case "OutlineMode":
                this.w3.cf();
                break;
            case "ShowDefaultTooltip":
                this.w3.ci();
                break;
            case "Title":
                this.w2.title = this.title;
                break;
            case "LegendItemBadgeMode":
                this.w3.cb();
                break;
            case "LegendItemBadgeShape":
                this.w3.cc();
                break;
            case "Legend":
                this.w2.legend = this.legend;
                this.cw.ay();
                break;
        }
    };
    GeographicMapSeriesHost.prototype.w6 = function () {
        if (this.dc == null || this.w2 == null) {
            return;
        }
        if (!isNaN_(this.w4)) {
            if (this.dc.v5.width > this.w4) {
                var hs_ = this.w2;
                var v_ = 1;
                hs_.visibility = v_;
            }
            else {
                var hs2_ = this.w2;
                var v2_ = 0;
                hs2_.visibility = v2_;
            }
        }
    };
    GeographicMapSeriesHost.prototype.w8 = function (a, b) {
        this.w6();
    };
    GeographicMapSeriesHost.prototype.rs = function (a) {
        _super.prototype.rs.call(this, a);
        if (this.w2 != null) {
            this.w2.rs(a);
        }
    };
    GeographicMapSeriesHost.prototype.q5 = function (a) {
        _super.prototype.q5.call(this, a);
        if (this.w2 != null) {
            this.w2.qn();
        }
    };
    GeographicMapSeriesHost.prototype.rr = function (a, b, c, d, e) {
        if (this.w2 != null) {
            this.w2.rr(a, b, c, d, e);
        }
    };
    GeographicMapSeriesHost.prototype.a2 = function (a, b) {
        return this.w2.a2(a, b);
    };
    GeographicMapSeriesHost.prototype.se = function () {
        _super.prototype.se.call(this);
        this.w2.se();
    };
    GeographicMapSeriesHost.prototype.get_coercionMethods = function () {
        return this._coercionMethods;
    };
    GeographicMapSeriesHost.prototype.set_coercionMethods = function (a) {
        this._coercionMethods = a;
        this.w2.coercionMethods = a;
    };
    GeographicMapSeriesHost.prototype.pz = function (a) {
        _super.prototype.pz.call(this, a);
        if (this.w2 != null) {
            var b = this.w2.km();
            this.o8(a, b);
        }
    };
    GeographicMapSeriesHost.$t = markType(GeographicMapSeriesHost, 'GeographicMapSeriesHost', Series.$);
    GeographicMapSeriesHost.w9 = DependencyProperty.i("VisibleFromScale", Number_$type, GeographicMapSeriesHost.$, new PropertyMetadata(2, 1, function (a, b) {
        var c = a;
        c.raisePropertyChanged("VisibleFromScale", b.oldValue, b.newValue);
    }));
    return GeographicMapSeriesHost;
}(Series));
export { GeographicMapSeriesHost };
/**
 * @hidden
 */
var HostSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HostSeriesView, _super);
    function HostSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b4 = a;
        return _this;
    }
    HostSeriesView.prototype.aw = function (a, b) {
        _super.prototype.aw.call(this, a, b);
    };
    HostSeriesView.prototype.b9 = function () {
        this.b4.legendItemVisibility = 1;
        this.b4.w2.legendItemVisibility = 0;
        this.b4.w2.itemsSource = this.b4.itemsSource;
        this.b4.w2.index = this.b4.index;
        this.b4.w2.vh = this.b4.vh;
        this.b4.w2.vx = this.b4.vh;
        this.b4.w2.cj = this.b4.cj;
        this.b4.w2.jj = this.b4.jj;
        this.b4.w2.kd = this.b4.kd;
        this.b4.w2._opacity = this.b4._opacity;
        this.b4.w2.jp = this.b4.jp;
        this.b4.w2.ik = this.b4.ik;
        this.b4.w2.jg = this.b4.jg;
        this.b4.w2.gp = this.b4.gp;
        this.b4.w2.legendItemBadgeShape = this.b4.legendItemBadgeShape;
        this.b4.w2.be = this.b4.be;
    };
    HostSeriesView.prototype.ca = function () {
        this.b4.w2.itemsSource = this.b4.itemsSource;
    };
    HostSeriesView.prototype.ch = function () {
        this.b4.w2.jj = this.b4.jj;
    };
    HostSeriesView.prototype.ck = function () {
        this.b4.w2.kd = this.b4.kd;
    };
    HostSeriesView.prototype.ce = function () {
        this.b4.w2._opacity = this.b4._opacity;
    };
    HostSeriesView.prototype.cj = function () {
        this.b4.w2.jp = this.b4.jp;
    };
    HostSeriesView.prototype.b8 = function () {
        this.b4.w2.vh = this.b4.vh;
    };
    HostSeriesView.prototype.cg = function () {
        this.b4.w2.vx = this.b4.vx;
    };
    HostSeriesView.prototype.b5 = function () {
        this.b4.w2.vh = this.b4.vb;
    };
    HostSeriesView.prototype.b6 = function () {
        this.b4.w2.vx = this.b4.vf;
    };
    HostSeriesView.prototype.cb = function () {
        this.b4.w2.be = this.b4.be;
    };
    HostSeriesView.prototype.cc = function () {
        this.b4.w2.legendItemBadgeShape = this.b4.legendItemBadgeShape;
    };
    HostSeriesView.prototype.b7 = function () {
        this.b4.w2.ik = this.b4.ik;
    };
    HostSeriesView.prototype.cd = function () {
        this.b4.w2.jg = this.b4.jg;
    };
    HostSeriesView.prototype.cf = function () {
        this.b4.w2.cj = this.b4.cj;
    };
    HostSeriesView.prototype.ci = function () {
        this.b4.w2.gp = this.b4.gp;
    };
    HostSeriesView.$t = markType(HostSeriesView, 'HostSeriesView', SeriesView.$);
    return HostSeriesView;
}(SeriesView));
export { HostSeriesView };
