/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { ShapeItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { BrushScale } from "igniteui-webcomponents-charts";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType, markDep } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
var GeographicShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesBase, _super);
    function GeographicShapeSeriesBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.xj = false;
        _this.xi = false;
        _this.assigningShapeStyle = null;
        _this.assigningShapeMarkerStyle = null;
        _this.xf = null;
        _this.xh = false;
        return _this;
    }
    GeographicShapeSeriesBase.prototype.ct = function () {
        return new GeographicShapeSeriesBaseView(this);
    };
    GeographicShapeSeriesBase.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.xe = a;
    };
    GeographicShapeSeriesBase.prototype.get_fe = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.get_ee = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.xe.cm();
                break;
            case "ShapeMemberPath":
                this.xe.co();
                break;
            case GeographicShapeSeriesBase.$$p[8]:
                this.xe.cn();
                break;
            case GeographicShapeSeriesBase.$$p[4]:
                this.w2.ya = this.xm;
                this.xj = this.xm;
                if (this.xm) {
                    var e = this.w2;
                    e.assigningShapeStyle = delegateCombine(e.assigningShapeStyle, runOn(this, this.x4));
                }
                else {
                    var f = this.w2;
                    f.assigningShapeStyle = delegateRemove(f.assigningShapeStyle, runOn(this, this.x4));
                }
                break;
            case GeographicShapeSeriesBase.$$p[3]:
                this.w2.x9 = this.xl;
                this.xi = this.xl;
                if (this.xm) {
                    var g = this.w2;
                    g.assigningShapeMarkerStyle = delegateCombine(g.assigningShapeMarkerStyle, runOn(this, this.x3));
                }
                else {
                    var h = this.w2;
                    h.assigningShapeMarkerStyle = delegateRemove(h.assigningShapeMarkerStyle, runOn(this, this.x3));
                }
                break;
            case GeographicShapeSeriesBase.$$p[5]:
                this.w2.xm = this.xd;
                break;
            case GeographicShapeSeriesBase.$$p[6]:
                this.w2.yr = this.xo;
                break;
            case GeographicShapeSeriesBase.$$p[7]:
                this.w2.ys = this.xp;
                break;
            case GeographicShapeSeriesBase.$$p[0]:
                this.w2.yw = this.xq;
                break;
            case GeographicShapeSeriesBase.$$p[1]:
                this.w2.xc = this.xc;
                break;
            case GeographicShapeSeriesBase.$$p[2]:
                this.w2.x5 = this.xk;
                break;
            case "ShapefileDataSource":
                if (c != null) {
                    var i = c;
                    if (this.xh) {
                        i.importCompleted = delegateRemove(i.importCompleted, runOn(this, this.x5));
                    }
                }
                if (d != null) {
                    var j = d;
                    if (j.count > 0) {
                        this.x6();
                        break;
                    }
                    this.xh = true;
                    j.importCompleted = delegateCombine(j.importCompleted, runOn(this, this.x5));
                }
                break;
        }
    };
    GeographicShapeSeriesBase.prototype.x4 = function (a, b) {
        if (this.assigningShapeStyle != null) {
            this.assigningShapeStyle(this, b);
        }
    };
    GeographicShapeSeriesBase.prototype.x3 = function (a, b) {
        if (this.assigningShapeMarkerStyle != null) {
            this.assigningShapeMarkerStyle(this, b);
        }
    };
    GeographicShapeSeriesBase.prototype.x5 = function (a, b) {
        this.x6();
    };
    GeographicShapeSeriesBase.prototype.x6 = function () {
        var sds_ = this.xg;
        var ext_ = sds_.externalObject;
        this.itemsSource = (ext_.getPointData());
    };
    Object.defineProperty(GeographicShapeSeriesBase.prototype, "xg", {
        get: function () {
            return this.xf;
        },
        set: function (a) {
            var b = this.xf;
            this.xf = a;
            if (b != this.xf) {
                this.raisePropertyChanged("ShapefileDataSource", b, this.xf);
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicShapeSeriesBase.prototype.get_g7 = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.set_g7 = function (a) {
        _super.prototype.set_g7.call(this, a);
    };
    GeographicShapeSeriesBase.$t = markType(GeographicShapeSeriesBase, 'GeographicShapeSeriesBase', GeographicMapSeriesHost.$);
    GeographicShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeriesBase, 'raisePropertyChanged', ['FillMemberPath:xq:x7', [2], 'FillScale:xc:x8', [BrushScale.$], 'FillScaleUseGlobalValues:xk:x9', [0, false], 'IsCustomShapeMarkerStyleAllowed:xl:ya', [0, false], 'IsCustomShapeStyleAllowed:xm:yb', [0, false], 'ItemSearchMode:xd:yc', [ShapeItemSearchMode_$type, enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:xo:yd', [1, 10000], 'ItemSearchThreshold:xp:ye', [1, 10000], 'ShapeFilterResolution:xn:yf', [1, 2], 'ShapeMemberPath:x1:yg', [2, "points"]]);
    return GeographicShapeSeriesBase;
}(GeographicMapSeriesHost));
export { GeographicShapeSeriesBase };
/**
 * @hidden
 */
var GeographicShapeSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesBaseView, _super);
    function GeographicShapeSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cl = null;
        _this.cl = a;
        return _this;
    }
    GeographicShapeSeriesBaseView.prototype.b9 = function () {
        _super.prototype.b9.call(this);
        this.cl.w2.y9 = this.cl.x1;
    };
    GeographicShapeSeriesBaseView.prototype.cm = function () {
        var a = this.cl.w2;
        if (this.cl.dc == null) {
            a.xg = null;
            a.xi = null;
            return;
        }
        a.xg = this.cl.dc.wv;
        a.xi = this.cl.dc.wx;
    };
    GeographicShapeSeriesBaseView.prototype.co = function () {
        this.cl.w2.y9 = this.cl.x1;
    };
    GeographicShapeSeriesBaseView.prototype.cn = function () {
        this.cl.w2.yo = this.cl.xn;
    };
    GeographicShapeSeriesBaseView.$t = markType(GeographicShapeSeriesBaseView, 'GeographicShapeSeriesBaseView', HostSeriesView.$);
    return GeographicShapeSeriesBaseView;
}(HostSeriesView));
export { GeographicShapeSeriesBaseView };
