/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicShapeSeriesBaseView } from "./GeographicShapeSeriesBaseView";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { Brush } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { MarkerType_$type } from "igniteui-webcomponents-charts";
import { MarkerFillMode_$type } from "igniteui-webcomponents-charts";
import { ScatterPolygonSeries } from "igniteui-webcomponents-charts";
import { markType, runOn, delegateCombine, typeCast, enumGetBox, markDep } from "igniteui-webcomponents-core";
import { StyleSelector } from "igniteui-webcomponents-charts";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { Style } from "igniteui-webcomponents-core";
import { MarkerOutlineMode_$type } from "igniteui-webcomponents-charts";
import { DataTemplate } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicShapeSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesView, _super);
    function GeographicShapeSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cp = null;
        _this.cp = a;
        if (!_this.r) {
            _this.cp.x1 = "points";
        }
        return _this;
    }
    GeographicShapeSeriesView.prototype.ax = function () {
        _super.prototype.ax.call(this);
        if (!this.r) {
            this.cp.zo = Defaults.aj;
            this.cp.jp = Defaults.p;
            this.cp.yn = Defaults.o;
            this.cp.yk = Defaults.d;
            this.cp.yi = Defaults.a;
        }
    };
    GeographicShapeSeriesView.prototype.b9 = function () {
        _super.prototype.b9.call(this);
        this.cp.w2.abv = this.cp.zq;
        this.cp.w2.aao = this.cp.yl;
        this.cp.w2.aba = this.cp.y6;
        this.cp.w2.aar = this.cp.yn;
        this.cp.w2.aaa = this.cp.yh;
    };
    GeographicShapeSeriesView.prototype.cu = function () {
        this.cp.w2.aba = this.cp.y6;
    };
    GeographicShapeSeriesView.prototype.cw = function () {
        this.cp.w2.aar = this.cp.yn;
    };
    GeographicShapeSeriesView.prototype.cr = function () {
        this.cp.w2.aaa = this.cp.yh;
    };
    GeographicShapeSeriesView.prototype.cv = function () {
        this.cp.w2.aaj = this.cp.yk;
    };
    GeographicShapeSeriesView.prototype.cq = function () {
        this.cp.w2.abr = this.cp.zn;
    };
    GeographicShapeSeriesView.prototype.cs = function () {
        this.cp.w2.abs = this.cp.zo;
    };
    GeographicShapeSeriesView.prototype.ct = function () {
        this.cp.w2.abu = this.cp.zp;
    };
    GeographicShapeSeriesView.prototype.cx = function () {
        this.cp.w2.aao = this.cp.yl;
    };
    GeographicShapeSeriesView.prototype.cy = function () {
        this.cp.w2.abv = this.cp.zq;
    };
    GeographicShapeSeriesView.$t = markType(GeographicShapeSeriesView, 'GeographicShapeSeriesView', GeographicShapeSeriesBaseView.$);
    return GeographicShapeSeriesView;
}(GeographicShapeSeriesBaseView));
export { GeographicShapeSeriesView };
/**
 * @hidden
 */
var GeographicShapeSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeries, _super);
    function GeographicShapeSeries() {
        var _this = _super.call(this) || this;
        _this.styleShape = null;
        _this.ab = GeographicShapeSeries.$;
        return _this;
    }
    GeographicShapeSeries.prototype.bk = function () {
        return new GeographicShapeSeries();
    };
    GeographicShapeSeries.prototype.get_fq = function () {
        return true;
    };
    GeographicShapeSeries.prototype.ct = function () {
        return new GeographicShapeSeriesView(this);
    };
    GeographicShapeSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.ym = a;
    };
    GeographicShapeSeries.prototype.w1 = function () {
        var a = new ScatterPolygonSeries();
        a.styleShape = delegateCombine(a.styleShape, runOn(this, this.y3));
        a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.y4));
        return a;
    };
    GeographicShapeSeries.prototype.y3 = function (a, b) {
        if (this.styleShape != null) {
            this.styleShape(this, b);
        }
    };
    GeographicShapeSeries.prototype.y4 = function (a, b) {
        var c = typeCast(ScatterPolygonSeries.$, this.w2);
        if (c == null) {
            return;
        }
    };
    GeographicShapeSeries.prototype.io = function () {
        return this.yn;
    };
    GeographicShapeSeries.prototype.vn = function () {
        return this.zl;
    };
    GeographicShapeSeries.prototype.vo = function () {
        return this.zm;
    };
    GeographicShapeSeries.prototype.s1 = function () {
        return this.y5;
    };
    GeographicShapeSeries.prototype.ma = function () {
        var a = typeCast(ScatterPolygonSeries.$, this.w2);
        if (a == null) {
            return "Unknown";
        }
        return a.ma();
    };
    GeographicShapeSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case GeographicShapeSeries.$$p[6]:
                this.w2.aah = this.yj;
                break;
            case GeographicShapeSeries.$$p[5]:
                this.w2.aad = this.yi;
                break;
            case GeographicShapeSeries.$$p[9]:
                this.ym.cu();
                break;
            case GeographicShapeSeries.$$p[10]:
                this.ym.cw();
                break;
            case GeographicShapeSeries.$$p[4]:
                this.ym.cr();
                break;
            case GeographicShapeSeries.$$p[11]:
                this.ym.cv();
                break;
            case GeographicShapeSeries.$$p[3]:
                this.ym.cq();
                break;
            case GeographicShapeSeries.$$p[7]:
                this.ym.cs();
                break;
            case GeographicShapeSeries.$$p[8]:
                this.ym.ct();
                break;
            case GeographicShapeSeries.$$p[13]:
                this.ym.cx();
                break;
            case GeographicShapeSeries.$$p[12]:
                this.ym.cy();
                break;
        }
    };
    GeographicShapeSeries.prototype.jl = function () {
        return 0.7;
    };
    GeographicShapeSeries.$t = markType(GeographicShapeSeries, 'GeographicShapeSeries', GeographicShapeSeriesBase.$);
    GeographicShapeSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeries, 'raisePropertyChanged', ['ActualMarkerBrush:zl:y7', [Brush.$], 'ActualMarkerOutline:zm:y8', [Brush.$], 'ActualMarkerTemplate:y5:y9', [DataTemplate.$, null], 'MarkerBrush:zn:za', [Brush.$], 'MarkerCollisionAvoidance:yh:zb', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:yi:zc', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:yj:zd', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:zo:ze', [Brush.$], 'MarkerStyle:zp:zf', [Style.$], 'MarkerTemplate:y6:zg', [DataTemplate.$, null], 'MarkerThickness:yn:zh', [1, DeviceUtils.g(2)], 'MarkerType:yk:zi', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'ShapeStyle:zq:zj', [Style.$, null], 'ShapeStyleSelector:yl:zk', [StyleSelector.$, null]]);
    return GeographicShapeSeries;
}(GeographicShapeSeriesBase));
export { GeographicShapeSeries };
