/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HostSeriesView } from "./HostSeriesView";
import { ScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicSymbolSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicSymbolSeriesView, _super);
    function GeographicSymbolSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cl = null;
        _this.cl = a;
        return _this;
    }
    GeographicSymbolSeriesView.prototype.ax = function () {
        _super.prototype.ax.call(this);
        if (!this.r) {
        }
    };
    GeographicSymbolSeriesView.prototype.b9 = function () {
        var a = this.cl.w2;
        _super.prototype.b9.call(this);
        a.aav = this.cl.yq;
        a.aa3 = this.cl.yo;
        a.xc = this.cl.xc;
        a.x4 = this.cl.xs;
        a.xl = this.cl.xd;
    };
    GeographicSymbolSeriesView.prototype.cn = function () {
        this.cl.w2.aav = this.cl.yq;
    };
    GeographicSymbolSeriesView.prototype.cm = function () {
        this.cl.w2.aa3 = this.cl.yo;
    };
    GeographicSymbolSeriesView.prototype.ct = function () {
        this.cl.w2.xc = this.cl.xc;
    };
    GeographicSymbolSeriesView.prototype.cr = function () {
        this.cl.w2.x4 = this.cl.xs;
    };
    GeographicSymbolSeriesView.prototype.cs = function () {
        this.cl.w2.xl = this.cl.xd;
    };
    GeographicSymbolSeriesView.prototype.cu = function () {
        this.cl.w2.aab = this.cl.xe;
    };
    GeographicSymbolSeriesView.prototype.cw = function () {
        this.cl.w2.xAxis = this.cl.dc.wv;
    };
    GeographicSymbolSeriesView.prototype.cx = function () {
        this.cl.w2.yAxis = this.cl.dc.wx;
    };
    GeographicSymbolSeriesView.prototype.cv = function () {
        var a = this.cl.w2;
        if (this.cl.dc == null) {
            a.xAxis = null;
            a.yAxis = null;
            return;
        }
        a.xAxis = this.cl.dc.wv;
        a.yAxis = this.cl.dc.wx;
    };
    GeographicSymbolSeriesView.prototype.cp = function () {
        this.cl.w2.yv = this.cl.ya;
    };
    GeographicSymbolSeriesView.prototype.co = function () {
        this.cl.w2.yl = this.cl.x6;
    };
    GeographicSymbolSeriesView.prototype.cq = function () {
        this.cl.w2.ym = this.cl.x7;
    };
    GeographicSymbolSeriesView.$t = markType(GeographicSymbolSeriesView, 'GeographicSymbolSeriesView', HostSeriesView.$);
    return GeographicSymbolSeriesView;
}(HostSeriesView));
export { GeographicSymbolSeriesView };
/**
 * @hidden
 */
var GeographicSymbolSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicSymbolSeries, _super);
    function GeographicSymbolSeries() {
        var _this = _super.call(this) || this;
        _this.yc = null;
        _this.yf = false;
        _this.ye = false;
        _this.assigningScatterStyle = null;
        _this.assigningScatterMarkerStyle = null;
        _this.ab = GeographicSymbolSeries.$;
        return _this;
    }
    GeographicSymbolSeries.prototype.bk = function () {
        return new GeographicSymbolSeries();
    };
    GeographicSymbolSeries.prototype.get_ej = function () {
        return true;
    };
    GeographicSymbolSeries.prototype.ct = function () {
        return new GeographicSymbolSeriesView(this);
    };
    GeographicSymbolSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.yd = a;
    };
    GeographicSymbolSeries.prototype.jl = function () {
        return 0.7;
    };
    GeographicSymbolSeries.prototype.w1 = function () {
        return new ScatterSeries();
    };
    GeographicSymbolSeries.prototype.get_fe = function () {
        return true;
    };
    GeographicSymbolSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.yd.cv();
                break;
            case GeographicSymbolSeries.$$p[5]:
                this.yd.cn();
                break;
            case GeographicSymbolSeries.$$p[4]:
                this.yd.cm();
                break;
            case GeographicSymbolSeries.$$p[6]:
                this.yd.cp();
                break;
            case "XAxis":
                this.yd.cw();
                break;
            case "YAxis":
                this.yd.cx();
                break;
            case GeographicSymbolSeries.$$p[1]:
                this.w2.zr = this.yh;
                this.yf = this.yh;
                if (this.yh) {
                    var e = this.w2;
                    e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.yv));
                }
                else {
                    var f = this.w2;
                    f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.yv));
                }
                break;
            case GeographicSymbolSeries.$$p[0]:
                this.w2.zq = this.yg;
                this.ye = this.yg;
                if (this.yh) {
                    var g = this.w2;
                    g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.yu));
                }
                else {
                    var h = this.w2;
                    h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.yu));
                }
                break;
            case GeographicSymbolSeries.$$p[2]:
                this.w2.za = this.yb;
                break;
            case GeographicSymbolSeries.$$p[3]:
                this.w2.aaa = this.yj;
                break;
        }
    };
    GeographicSymbolSeries.prototype.yv = function (a, b) {
        if (this.assigningScatterStyle != null) {
            this.assigningScatterStyle(this, b);
        }
    };
    GeographicSymbolSeries.prototype.yu = function (a, b) {
        if (this.assigningScatterMarkerStyle != null) {
            this.assigningScatterMarkerStyle(this, b);
        }
    };
    GeographicSymbolSeries.$t = markType(GeographicSymbolSeries, 'GeographicSymbolSeries', GeographicMarkerSeries.$);
    GeographicSymbolSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicSymbolSeries, 'raisePropertyChanged', ['IsCustomScatterMarkerStyleAllowed:yg:yw', [0, false], 'IsCustomScatterStyleAllowed:yh:yx', [0, false], 'ItemSearchMode:yb:yy', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:yj:yz', [1, 10000], 'LatitudeMemberPath:yo:y0', [2, null], 'LongitudeMemberPath:yq:y1', [2, null], 'MarkerCollisionAvoidance:ya:y2', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'UseLightweightMarkers:yi:y3', [0, false]]);
    return GeographicSymbolSeries;
}(GeographicMarkerSeries));
export { GeographicSymbolSeries };
