/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ShapeSeriesBase } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { EventArgs, runOn, delegateRemove, delegateCombine, typeCast, markType } from "igniteui-webcomponents-core";
import { XamGeographicMap } from "./XamGeographicMap";
import { ShapeSeriesViewBase } from "igniteui-webcomponents-charts";
import { RenderingContext } from "igniteui-webcomponents-core";
import { GeometryGroup } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { truncate } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var TileSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileSeries, _super);
    function TileSeries() {
        var _this = _super.call(this) || this;
        _this.aab = null;
        _this.aaa = null;
        _this.imageTilesReady = null;
        _this.aae = null;
        _this.aaf = false;
        _this.ab = TileSeries.$;
        return _this;
    }
    TileSeries.prototype.bk = function () {
        return new TileSeries();
    };
    TileSeries.prototype.get_f3 = function () {
        return true;
    };
    TileSeries.prototype.ct = function () {
        return new TileSeriesView(this);
    };
    TileSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.z9 = a;
    };
    TileSeries.prototype.get_yc = function () {
        return false;
    };
    Object.defineProperty(TileSeries.prototype, "aad", {
        get: function () {
            return this.aab;
        },
        set: function (a) {
            var b = a != this.aad;
            if (b) {
                var c = this.aad;
                this.aab = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TileSeries.prototype, "aac", {
        get: function () {
            return this.aaa;
        },
        set: function (a) {
            var b = this.aaa;
            this.aaa = a;
            this.raisePropertyChanged("ActualTileImagery", b, this.aaa);
        },
        enumerable: false,
        configurable: true
    });
    TileSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        var e;
        var f;
        switch (b) {
            case "TileImagery":
                e = c;
                f = d;
                if (e != null) {
                    e.propertyChanged = delegateRemove(e.propertyChanged, runOn(this, this.aai));
                }
                if (f != null) {
                    f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.aai));
                }
                this.z9.dl(e, f);
                this.rs(false);
                this.ql();
                break;
            case "ActualTileImagery":
                e = c;
                f = d;
                if (e != null) {
                    e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.aaj));
                    e.deferralHandler = null;
                }
                if (f != null) {
                    f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.aaj));
                    f.deferralHandler = this;
                }
                this.z9.dk(e, f);
                if (f != null && typeCast(XamGeographicMap.$, this.dc) !== null) {
                    f.geographicMap = this.dc;
                    this.aal(this.cw);
                    this.z9.dh(this.dc.v5);
                }
                this.ql();
                break;
            case "ActualWindowRect":
                this.z9.dh(d);
                break;
            case "WorldRect":
                this.z9.dp(d);
                break;
            case "SeriesViewer":
                var g = c;
                var h = d;
                if (g != null && this.aac != null) {
                    this.aac.be(null);
                }
                if (h != null && this.aac != null) {
                    this.aac.be(this.cw.z);
                }
                break;
            case "ActualBrush":
            case "ActualOutline":
            case "ActualThickness":
                this.qn();
                break;
        }
    };
    TileSeries.prototype.aai = function (a, b) {
        if (b.propertyName == "MultiScaleImage") {
            this.aal(this.cw);
        }
    };
    TileSeries.prototype.aaj = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new EventArgs());
        }
        if (!this.aaf) {
            this.z9.dm();
        }
    };
    TileSeries.prototype.register = function (a, b) {
        this.aae = b;
    };
    TileSeries.prototype.unRegister = function (a) {
        this.aae = null;
    };
    TileSeries.prototype.deferredRefresh = function () {
        this.rs(false);
    };
    TileSeries.prototype.deferAction = function (a) {
        if (this.jz != null) {
            this.jz.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    TileSeries.prototype.ss = function (a, b) {
        this.z9.dn();
        _super.prototype.ss.call(this, a, b);
    };
    TileSeries.prototype.rt = function (a) {
        _super.prototype.rt.call(this, a);
        this.aak(a, this.cw);
    };
    TileSeries.prototype.aak = function (a, b) {
        var c;
        var d;
        var e = b;
        var f = b.getViewInfo(c, d);
        c = f.p0;
        d = f.p1;
        this.aal(b);
        if (this.aae != null) {
            this.aaf = true;
            this.aae(a);
            this.aaf = false;
        }
        e.dm();
    };
    TileSeries.prototype.rr = function (a, b, c, d, e) {
        _super.prototype.rr.call(this, a, b, c, d, e);
        var f = this.hn.item(d);
        f.a6(c);
        if (this.d6(f)) {
            return;
        }
        this.zp(f);
    };
    TileSeries.prototype.aal = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.aad != null && this.aad.ao != null) {
            if (this.aad != this.aac) {
                this.aac = this.aad;
            }
            if (this.aac != null && !b.isEmpty) {
                if (this.aac.width != b.width) {
                    this.aac.width = b.width;
                }
                if (this.aac.height != b.height) {
                    this.aac.height = b.height;
                }
            }
        }
    };
    TileSeries.prototype.o5 = function (a, b) {
        _super.prototype.o5.call(this, a, b);
        b.di();
    };
    TileSeries.$t = markType(TileSeries, 'TileSeries', ShapeSeriesBase.$, [IMapRenderDeferralHandler_$type]);
    return TileSeries;
}(ShapeSeriesBase));
export { TileSeries };
/**
 * @hidden
 */
var TileSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileSeriesView, _super);
    function TileSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.de = null;
        _this.dq = new GeometryGroup();
        _this.dg = null;
        _this.df = null;
        _this.de = a;
        return _this;
    }
    TileSeriesView.prototype.ax = function () {
        _super.prototype.ax.call(this);
        if (!this.r) {
            this.de.vx = Defaults.ao;
            this.de.vh = Defaults.an;
        }
    };
    TileSeriesView.prototype.co = function (a, b) {
        if (b.c.count > 0) {
            this.dq.d.add(b);
        }
    };
    TileSeriesView.prototype.c9 = function (a, b) {
        return this.da(a, b, true);
    };
    TileSeriesView.prototype.c8 = function (a, b) {
        return null;
    };
    TileSeriesView.prototype.cs = function (a, b) {
    };
    TileSeriesView.prototype.cq = function (a, b, c) {
    };
    TileSeriesView.prototype.cy = function () {
        _super.prototype.cy.call(this);
        this.dq.d.clear();
    };
    TileSeriesView.prototype.cx = function () {
        _super.prototype.cx.call(this);
        this.av();
    };
    TileSeriesView.prototype.dh = function (a) {
        if (this.de.aad != null) {
            this.de.aad.windowRect = a;
        }
    };
    TileSeriesView.prototype.dk = function (a, b) {
        if (this.dg == null) {
            this.dg = this.f.jz.createElement("canvas");
            var c = this.f.jz.get2DCanvasContext(this.dg);
            this.df = new RenderingContext(new CanvasViewRenderer(), c);
            this.dg.setAttribute("width", this.b1.width.toString());
            this.dg.setAttribute("height", this.b1.height.toString());
        }
        if (a != null) {
            a.bd(null);
            a.be(null);
            a.imagesChanged = delegateRemove(a.imagesChanged, runOn(this, this.dj));
        }
        if (b != null) {
            if (this.z != null) {
                b.be(this.z);
            }
            b.bd(this.df);
            b.bf(this.b1);
            b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.dj));
        }
    };
    TileSeriesView.prototype.dj = function (a, b) {
        this.av();
    };
    TileSeriesView.prototype.dl = function (a, b) {
    };
    TileSeriesView.prototype.dn = function () {
        if (this.dg != null) {
            this.dg.setAttribute("width", this.b1.width.toString());
            this.dg.setAttribute("height", this.b1.height.toString());
        }
        if (this.de.aad != null) {
            this.de.aad.bf(this.b1);
        }
    };
    TileSeriesView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        if (b) {
            return;
        }
        if (this.dg == null) {
            return;
        }
        var c = false;
        if (this.dq.d.count > 0) {
            c = true;
            this.l.aa();
            this.l.r(this.dq);
            var d = this.l.h();
            d.clip();
        }
        var e = truncate(Math.round(this.b1.left));
        var f = truncate(Math.round(this.b1.top));
        var g = truncate(Math.round(this.b1.width));
        var h = truncate(Math.round(this.b1.height));
        this.l.o(this.dg.getNativeElement(), 1, e, f, g, h, e, f, g, h);
        if (c) {
            this.l.z();
        }
    };
    TileSeriesView.prototype.dm = function () {
        this.av();
    };
    TileSeriesView.prototype.di = function () {
    };
    TileSeriesView.prototype.dp = function (a) {
        if (this.de.aad != null) {
            this.de.aad.a6();
        }
    };
    TileSeriesView.$t = markType(TileSeriesView, 'TileSeriesView', ShapeSeriesViewBase.$);
    return TileSeriesView;
}(ShapeSeriesViewBase));
export { TileSeriesView };
