import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ShapeItemSearchMode } from "igniteui-webcomponents-charts";
import { BrushScale } from "igniteui-webcomponents-charts";
import { ShapefileConverter } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { Type } from "igniteui-webcomponents-core";
import { AssigningShapeStyleEventArgs } from "igniteui-webcomponents-charts";
import { AssigningShapeMarkerStyleEventArgs } from "igniteui-webcomponents-charts";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
export declare abstract class GeographicShapeSeriesBase extends GeographicMapSeriesHost {
    static $t: Type;
    protected ct(): SeriesView;
    xe: GeographicShapeSeriesBaseView;
    q1(a: SeriesView): void;
    x1: string;
    protected get_fe(): boolean;
    protected get_ee(): boolean;
    xm: boolean;
    xl: boolean;
    protected xj: boolean;
    protected xi: boolean;
    xd: ShapeItemSearchMode;
    xp: number;
    xq: string;
    xc: BrushScale;
    xk: boolean;
    xo: number;
    assigningShapeStyle: (sender: any, args: AssigningShapeStyleEventArgs) => void;
    assigningShapeMarkerStyle: (sender: any, args: AssigningShapeMarkerStyleEventArgs) => void;
    protected ra(a: any, b: string, c: any, d: any): void;
    private x4;
    private x3;
    private x5;
    private x6;
    private xf;
    private xh;
    get xg(): ShapefileConverter;
    set xg(a: ShapefileConverter);
    xn: number;
    protected get_g7(): boolean;
    protected set_g7(a: boolean): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicShapeSeriesBaseView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicShapeSeriesBase);
    private cl;
    b9(): void;
    cm(): void;
    co(): void;
    cn(): void;
}
