import { HostSeriesView } from "./HostSeriesView";
import { SeriesView } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { Series } from "igniteui-webcomponents-charts";
import { Type } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode } from "igniteui-webcomponents-charts";
import { AssigningScatterStyleEventArgs } from "igniteui-webcomponents-charts";
import { AssigningScatterMarkerStyleEventArgs } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
export declare class GeographicSymbolSeriesView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicSymbolSeries);
    private cl;
    ax(): void;
    b9(): void;
    cn(): void;
    cm(): void;
    ct(): void;
    cr(): void;
    cs(): void;
    cu(): void;
    cw(): void;
    cx(): void;
    cv(): void;
    cp(): void;
    co(): void;
    cq(): void;
}
/**
 * @hidden
 */
export declare class GeographicSymbolSeries extends GeographicMarkerSeries {
    static $t: Type;
    protected bk(): Series;
    protected get_ej(): boolean;
    constructor();
    protected ct(): SeriesView;
    q1(a: SeriesView): void;
    yd: GeographicSymbolSeriesView;
    protected jl(): number;
    protected w1(): Series;
    private yc;
    yo: string;
    yq: string;
    ya: CollisionAvoidanceType;
    yh: boolean;
    yg: boolean;
    protected yf: boolean;
    protected ye: boolean;
    protected get_fe(): boolean;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    yb: ScatterItemSearchMode;
    yj: number;
    protected ra(a: any, b: string, c: any, d: any): void;
    private yv;
    private yu;
    yi: boolean;
    static $$p: string[];
}
