/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { HighDensityScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { Color } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { typeCast, markType, runOn, delegateCombine, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicHighDensityScatterSeriesView = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cl = null;
            this.cl = a;
        }
        b9() {
            super.b9();
            let a = typeCast(HighDensityScatterSeries.$, this.cl.w2);
            a.zb = this.cl.xr;
            a.zj = this.cl.xp;
            a.xo = this.cl.xe;
            a.xn = this.cl.xd;
            a.f8 = this.cl.xc;
            a.yj = this.cl.xg;
            a.yi = this.cl.xf;
            a.aah = this.cl.ya;
            a.aag = this.cl.x9;
            a.yv = this.cl.xj;
        }
        cr() {
            this.cl.w2.zb = this.cl.xr;
        }
        cq() {
            this.cl.w2.zj = this.cl.xp;
        }
        cw() {
            this.cl.w2.xo = this.cl.xe;
        }
        cu() {
            this.cl.w2.xn = this.cl.xd;
        }
        cs() {
            this.cl.w2.f8 = this.cl.xc;
        }
        cp() {
            this.cl.w2.yj = this.cl.xg;
        }
        cn() {
            this.cl.w2.yi = this.cl.xf;
        }
        cv() {
            let a = typeCast(HighDensityScatterSeries.$, this.cl.w2);
            if (this.cl.dc == null) {
                a.w7 = null;
                a.w9 = null;
                return;
            }
            a.w7 = this.cl.dc.wv;
            a.w9 = this.cl.dc.wx;
        }
        cx() {
            this.cl.w2.w7 = this.cl.dc.wv;
        }
        cy() {
            this.cl.w2.w9 = this.cl.dc.wx;
        }
        co() {
            this.cl.w2.aah = this.cl.ya;
        }
        cm() {
            this.cl.w2.aag = this.cl.x9;
        }
        ct() {
            this.cl.w2.yv = this.cl.xj;
        }
        ax() {
            super.ax();
            if (!this.r) {
                this.cl.ya = Defaults.aq;
                this.cl.x9 = Defaults.ap;
                this.cl.vh = Defaults.al;
                this.cl.vx = Defaults.ak;
            }
        }
    }
    GeographicHighDensityScatterSeriesView.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesView, 'GeographicHighDensityScatterSeriesView', HostSeriesView.$);
    return GeographicHighDensityScatterSeriesView;
})();
/**
 * @hidden
 */
export let GeographicHighDensityScatterSeries = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeries extends GeographicMapSeriesHost {
        bk() {
            return new GeographicHighDensityScatterSeries();
        }
        jk() {
            if (!isNaN_(this.jj)) {
                return super.jk();
            }
            return Defaults.q;
        }
        get_fo() {
            return true;
        }
        constructor() {
            super();
            this.xa = null;
            this.progressiveLoadStatusChanged = null;
            this.xi = 0;
            this.ab = GeographicHighDensityScatterSeries.$;
        }
        ct() {
            return new GeographicHighDensityScatterSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.xb = a;
        }
        w1() {
            this.xa = new HighDensityScatterSeries();
            return this.xa;
        }
        get xk() {
            return this.xi;
        }
        set xk(a) {
            let b = this.xi;
            this.xi = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.xi);
        }
        w7(a, b) {
            super.w7(a, b);
            let c = this.w2;
            c.progressiveLoadStatusChanged = delegateCombine(c.progressiveLoadStatusChanged, runOn(this, this.xy));
            let d = this.w2;
            d.propertyUpdated = delegateCombine(d.propertyUpdated, runOn(this, this.xx));
        }
        xy(a, b) {
            this.xk = b.currentStatus;
            if (this.progressiveLoadStatusChanged != null) {
                this.progressiveLoadStatusChanged(this, b);
            }
        }
        xx(a, b) {
            if (this.xa == null) {
                return;
            }
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.xb.cv();
                    break;
                case GeographicHighDensityScatterSeries.$$p[5]:
                    this.xb.cr();
                    break;
                case GeographicHighDensityScatterSeries.$$p[4]:
                    this.xb.cq();
                    break;
                case GeographicHighDensityScatterSeries.$$p[9]:
                    this.xb.cw();
                    break;
                case GeographicHighDensityScatterSeries.$$p[8]:
                    this.xb.cu();
                    break;
                case GeographicHighDensityScatterSeries.$$p[6]:
                    this.xb.cs();
                    break;
                case "XAxis":
                    this.xb.cx();
                    break;
                case "YAxis":
                    this.xb.cy();
                    break;
                case GeographicHighDensityScatterSeries.$$p[3]:
                    this.xb.cp();
                    break;
                case GeographicHighDensityScatterSeries.$$p[1]:
                    this.xb.cn();
                    break;
                case GeographicHighDensityScatterSeries.$$p[2]:
                    this.xb.co();
                    break;
                case GeographicHighDensityScatterSeries.$$p[0]:
                    this.xb.cm();
                    break;
                case GeographicHighDensityScatterSeries.$$p[7]:
                    this.xb.ct();
                    break;
            }
        }
        get_g7() {
            return true;
        }
        set_g7(a) {
            super.set_g7(a);
        }
    }
    GeographicHighDensityScatterSeries.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeries, 'GeographicHighDensityScatterSeries', GeographicMapSeriesHost.$);
    GeographicHighDensityScatterSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicHighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:x9:xz', [Color.$, Defaults.ap], 'HeatMaximum:xf:x0', [1, 50], 'HeatMinimumColor:ya:x1', [Color.$, Defaults.aq], 'HeatMinimum:xg:x2', [1, 0], 'LatitudeMemberPath:xp:x3', [2, null], 'LongitudeMemberPath:xr:x4', [2, null], 'MouseOverEnabled:xc:x5', [0, false], 'PointExtent:xj:x6', [1, 1], 'ProgressiveLoad:xd:x7', [0, true], 'UseBruteForce:xe:x8', [0, false]]);
    return GeographicHighDensityScatterSeries;
})();
