/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { ScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicSymbolSeriesView = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cl = null;
            this.cl = a;
        }
        ax() {
            super.ax();
            if (!this.r) {
            }
        }
        b9() {
            let a = this.cl.w2;
            super.b9();
            a.aav = this.cl.yq;
            a.aa3 = this.cl.yo;
            a.xc = this.cl.xc;
            a.x4 = this.cl.xs;
            a.xl = this.cl.xd;
        }
        cn() {
            this.cl.w2.aav = this.cl.yq;
        }
        cm() {
            this.cl.w2.aa3 = this.cl.yo;
        }
        ct() {
            this.cl.w2.xc = this.cl.xc;
        }
        cr() {
            this.cl.w2.x4 = this.cl.xs;
        }
        cs() {
            this.cl.w2.xl = this.cl.xd;
        }
        cu() {
            this.cl.w2.aab = this.cl.xe;
        }
        cw() {
            this.cl.w2.xAxis = this.cl.dc.wv;
        }
        cx() {
            this.cl.w2.yAxis = this.cl.dc.wx;
        }
        cv() {
            let a = this.cl.w2;
            if (this.cl.dc == null) {
                a.xAxis = null;
                a.yAxis = null;
                return;
            }
            a.xAxis = this.cl.dc.wv;
            a.yAxis = this.cl.dc.wx;
        }
        cp() {
            this.cl.w2.yv = this.cl.ya;
        }
        co() {
            this.cl.w2.yl = this.cl.x6;
        }
        cq() {
            this.cl.w2.ym = this.cl.x7;
        }
    }
    GeographicSymbolSeriesView.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesView, 'GeographicSymbolSeriesView', HostSeriesView.$);
    return GeographicSymbolSeriesView;
})();
/**
 * @hidden
 */
export let GeographicSymbolSeries = /*@__PURE__*/ (() => {
    class GeographicSymbolSeries extends GeographicMarkerSeries {
        bk() {
            return new GeographicSymbolSeries();
        }
        get_ej() {
            return true;
        }
        constructor() {
            super();
            this.yc = null;
            this.yf = false;
            this.ye = false;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ab = GeographicSymbolSeries.$;
        }
        ct() {
            return new GeographicSymbolSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.yd = a;
        }
        jl() {
            return 0.7;
        }
        w1() {
            return new ScatterSeries();
        }
        get_fe() {
            return true;
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.yd.cv();
                    break;
                case GeographicSymbolSeries.$$p[5]:
                    this.yd.cn();
                    break;
                case GeographicSymbolSeries.$$p[4]:
                    this.yd.cm();
                    break;
                case GeographicSymbolSeries.$$p[6]:
                    this.yd.cp();
                    break;
                case "XAxis":
                    this.yd.cw();
                    break;
                case "YAxis":
                    this.yd.cx();
                    break;
                case GeographicSymbolSeries.$$p[1]:
                    this.w2.zr = this.yh;
                    this.yf = this.yh;
                    if (this.yh) {
                        let e = this.w2;
                        e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.yv));
                    }
                    else {
                        let f = this.w2;
                        f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.yv));
                    }
                    break;
                case GeographicSymbolSeries.$$p[0]:
                    this.w2.zq = this.yg;
                    this.ye = this.yg;
                    if (this.yh) {
                        let g = this.w2;
                        g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.yu));
                    }
                    else {
                        let h = this.w2;
                        h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.yu));
                    }
                    break;
                case GeographicSymbolSeries.$$p[2]:
                    this.w2.za = this.yb;
                    break;
                case GeographicSymbolSeries.$$p[3]:
                    this.w2.aaa = this.yj;
                    break;
            }
        }
        yv(a, b) {
            if (this.assigningScatterStyle != null) {
                this.assigningScatterStyle(this, b);
            }
        }
        yu(a, b) {
            if (this.assigningScatterMarkerStyle != null) {
                this.assigningScatterMarkerStyle(this, b);
            }
        }
    }
    GeographicSymbolSeries.$t = /*@__PURE__*/ markType(GeographicSymbolSeries, 'GeographicSymbolSeries', GeographicMarkerSeries.$);
    GeographicSymbolSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicSymbolSeries, 'raisePropertyChanged', ['IsCustomScatterMarkerStyleAllowed:yg:yw', [0, false], 'IsCustomScatterStyleAllowed:yh:yx', [0, false], 'ItemSearchMode:yb:yy', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:yj:yz', [1, 10000], 'LatitudeMemberPath:yo:y0', [2, null], 'LongitudeMemberPath:yq:y1', [2, null], 'MarkerCollisionAvoidance:ya:y2', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'UseLightweightMarkers:yi:y3', [0, false]]);
    return GeographicSymbolSeries;
})();
