/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { EventArgs, runOn, delegateRemove, delegateCombine, typeCast, markType } from "igniteui-webcomponents-core";
import { XamGeographicMap } from "./XamGeographicMap";
import { ShapeSeriesViewBase } from "igniteui-webcomponents-charts";
import { RenderingContext } from "igniteui-webcomponents-core";
import { GeometryGroup } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { truncate } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let TileSeries = /*@__PURE__*/ (() => {
    class TileSeries extends ShapeSeriesBase {
        bk() {
            return new TileSeries();
        }
        get_f3() {
            return true;
        }
        constructor() {
            super();
            this.aab = null;
            this.aaa = null;
            this.imageTilesReady = null;
            this.aae = null;
            this.aaf = false;
            this.ab = TileSeries.$;
        }
        ct() {
            return new TileSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.z9 = a;
        }
        get_yc() {
            return false;
        }
        get aad() {
            return this.aab;
        }
        set aad(a) {
            let b = a != this.aad;
            if (b) {
                let c = this.aad;
                this.aab = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        }
        get aac() {
            return this.aaa;
        }
        set aac(a) {
            let b = this.aaa;
            this.aaa = a;
            this.raisePropertyChanged("ActualTileImagery", b, this.aaa);
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            let e;
            let f;
            switch (b) {
                case "TileImagery":
                    e = c;
                    f = d;
                    if (e != null) {
                        e.propertyChanged = delegateRemove(e.propertyChanged, runOn(this, this.aai));
                    }
                    if (f != null) {
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.aai));
                    }
                    this.z9.dl(e, f);
                    this.rs(false);
                    this.ql();
                    break;
                case "ActualTileImagery":
                    e = c;
                    f = d;
                    if (e != null) {
                        e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.aaj));
                        e.deferralHandler = null;
                    }
                    if (f != null) {
                        f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.aaj));
                        f.deferralHandler = this;
                    }
                    this.z9.dk(e, f);
                    if (f != null && typeCast(XamGeographicMap.$, this.dc) !== null) {
                        f.geographicMap = this.dc;
                        this.aal(this.cw);
                        this.z9.dh(this.dc.v5);
                    }
                    this.ql();
                    break;
                case "ActualWindowRect":
                    this.z9.dh(d);
                    break;
                case "WorldRect":
                    this.z9.dp(d);
                    break;
                case "SeriesViewer":
                    let g = c;
                    let h = d;
                    if (g != null && this.aac != null) {
                        this.aac.be(null);
                    }
                    if (h != null && this.aac != null) {
                        this.aac.be(this.cw.z);
                    }
                    break;
                case "ActualBrush":
                case "ActualOutline":
                case "ActualThickness":
                    this.qn();
                    break;
            }
        }
        aai(a, b) {
            if (b.propertyName == "MultiScaleImage") {
                this.aal(this.cw);
            }
        }
        aaj(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new EventArgs());
            }
            if (!this.aaf) {
                this.z9.dm();
            }
        }
        register(a, b) {
            this.aae = b;
        }
        unRegister(a) {
            this.aae = null;
        }
        deferredRefresh() {
            this.rs(false);
        }
        deferAction(a) {
            if (this.jz != null) {
                this.jz.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        ss(a, b) {
            this.z9.dn();
            super.ss(a, b);
        }
        rt(a) {
            super.rt(a);
            this.aak(a, this.cw);
        }
        aak(a, b) {
            let c;
            let d;
            let e = b;
            let f = b.getViewInfo(c, d);
            c = f.p0;
            d = f.p1;
            this.aal(b);
            if (this.aae != null) {
                this.aaf = true;
                this.aae(a);
                this.aaf = false;
            }
            e.dm();
        }
        rr(a, b, c, d, e) {
            super.rr(a, b, c, d, e);
            let f = this.hn.item(d);
            f.a6(c);
            if (this.d6(f)) {
                return;
            }
            this.zp(f);
        }
        aal(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.aad != null && this.aad.ao != null) {
                if (this.aad != this.aac) {
                    this.aac = this.aad;
                }
                if (this.aac != null && !b.isEmpty) {
                    if (this.aac.width != b.width) {
                        this.aac.width = b.width;
                    }
                    if (this.aac.height != b.height) {
                        this.aac.height = b.height;
                    }
                }
            }
        }
        o5(a, b) {
            super.o5(a, b);
            b.di();
        }
    }
    TileSeries.$t = /*@__PURE__*/ markType(TileSeries, 'TileSeries', ShapeSeriesBase.$, [IMapRenderDeferralHandler_$type]);
    return TileSeries;
})();
/**
 * @hidden
 */
export let TileSeriesView = /*@__PURE__*/ (() => {
    class TileSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.de = null;
            this.dq = new GeometryGroup();
            this.dg = null;
            this.df = null;
            this.de = a;
        }
        ax() {
            super.ax();
            if (!this.r) {
                this.de.vx = Defaults.ao;
                this.de.vh = Defaults.an;
            }
        }
        co(a, b) {
            if (b.c.count > 0) {
                this.dq.d.add(b);
            }
        }
        c9(a, b) {
            return this.da(a, b, true);
        }
        c8(a, b) {
            return null;
        }
        cs(a, b) {
        }
        cq(a, b, c) {
        }
        cy() {
            super.cy();
            this.dq.d.clear();
        }
        cx() {
            super.cx();
            this.av();
        }
        dh(a) {
            if (this.de.aad != null) {
                this.de.aad.windowRect = a;
            }
        }
        dk(a, b) {
            if (this.dg == null) {
                this.dg = this.f.jz.createElement("canvas");
                let c = this.f.jz.get2DCanvasContext(this.dg);
                this.df = new RenderingContext(new CanvasViewRenderer(), c);
                this.dg.setAttribute("width", this.b1.width.toString());
                this.dg.setAttribute("height", this.b1.height.toString());
            }
            if (a != null) {
                a.bd(null);
                a.be(null);
                a.imagesChanged = delegateRemove(a.imagesChanged, runOn(this, this.dj));
            }
            if (b != null) {
                if (this.z != null) {
                    b.be(this.z);
                }
                b.bd(this.df);
                b.bf(this.b1);
                b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.dj));
            }
        }
        dj(a, b) {
            this.av();
        }
        dl(a, b) {
        }
        dn() {
            if (this.dg != null) {
                this.dg.setAttribute("width", this.b1.width.toString());
                this.dg.setAttribute("height", this.b1.height.toString());
            }
            if (this.de.aad != null) {
                this.de.aad.bf(this.b1);
            }
        }
        bc(a, b) {
            super.bc(a, b);
            if (b) {
                return;
            }
            if (this.dg == null) {
                return;
            }
            let c = false;
            if (this.dq.d.count > 0) {
                c = true;
                this.l.aa();
                this.l.r(this.dq);
                let d = this.l.h();
                d.clip();
            }
            let e = truncate(Math.round(this.b1.left));
            let f = truncate(Math.round(this.b1.top));
            let g = truncate(Math.round(this.b1.width));
            let h = truncate(Math.round(this.b1.height));
            this.l.o(this.dg.getNativeElement(), 1, e, f, g, h, e, f, g, h);
            if (c) {
                this.l.z();
            }
        }
        dm() {
            this.av();
        }
        di() {
        }
        dp(a) {
            if (this.de.aad != null) {
                this.de.aad.a6();
            }
        }
    }
    TileSeriesView.$t = /*@__PURE__*/ markType(TileSeriesView, 'TileSeriesView', ShapeSeriesViewBase.$);
    return TileSeriesView;
})();
