/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicXYTriangulatingSeriesView } from "./GeographicXYTriangulatingSeriesView";
import { Defaults } from "igniteui-webcomponents-charts";
import { ScatterContourSeries } from "igniteui-webcomponents-charts";
import { markType, runOn, delegateCombine, typeCast, markDep } from "igniteui-webcomponents-core";
import { GeographicXYTriangulatingSeries } from "./GeographicXYTriangulatingSeries";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { ValueBrushScale } from "igniteui-webcomponents-charts";
import { ContourValueResolver } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicContourLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicContourLineSeriesView, _super);
    function GeographicContourLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.ct = null;
        _this.ct = a;
        return _this;
    }
    GeographicContourLineSeriesView.prototype.ax = function () {
        _super.prototype.ax.call(this);
        if (!this.r) {
            this.ct.jp = Defaults.m;
        }
    };
    GeographicContourLineSeriesView.prototype.b9 = function () {
        _super.prototype.b9.call(this);
        if (this.ct.w2 != null) {
            this.ct.xu.yx = this.ct.xx;
            this.ct.xu.y7 = this.ct.x1;
        }
    };
    GeographicContourLineSeriesView.prototype.cu = function () {
        if (this.ct.xu != null) {
            this.ct.xu.yx = this.ct.xx;
        }
    };
    GeographicContourLineSeriesView.prototype.cv = function () {
        if (this.ct.xu != null) {
            this.ct.xu.y7 = this.ct.x1;
        }
    };
    GeographicContourLineSeriesView.$t = markType(GeographicContourLineSeriesView, 'GeographicContourLineSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicContourLineSeriesView;
}(GeographicXYTriangulatingSeriesView));
export { GeographicContourLineSeriesView };
/**
 * @hidden
 */
var GeographicContourLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicContourLineSeries, _super);
    function GeographicContourLineSeries() {
        var _this = _super.call(this) || this;
        _this.triangulationStatusChanged = null;
        _this.ab = GeographicContourLineSeries.$;
        return _this;
    }
    GeographicContourLineSeries.prototype.bk = function () {
        return new GeographicContourLineSeries();
    };
    GeographicContourLineSeries.prototype.get_fj = function () {
        return true;
    };
    GeographicContourLineSeries.prototype.w7 = function (a, b) {
        _super.prototype.w7.call(this, a, b);
    };
    GeographicContourLineSeries.prototype.w1 = function () {
        this.xu = new ScatterContourSeries();
        var a = this.xu;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x4));
        var b = this.xu;
        b.propertyUpdated = delegateCombine(b.propertyUpdated, runOn(this, this.x5));
        return this.xu;
    };
    GeographicContourLineSeries.prototype.x4 = function (a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, b);
        }
    };
    GeographicContourLineSeries.prototype.x5 = function (a, b) {
        var c = typeCast(ScatterContourSeries.$, this.w2);
        if (c == null) {
            return;
        }
        if (b.propertyName == "ActualFillScale") {
            this.xw = c.yw;
        }
    };
    GeographicContourLineSeries.prototype.sj = function () {
        _super.prototype.sj.call(this);
    };
    GeographicContourLineSeries.prototype.ct = function () {
        return new GeographicContourLineSeriesView(this);
    };
    GeographicContourLineSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.xy = a;
    };
    GeographicContourLineSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case GeographicContourLineSeries.$$p[1]:
                this.xy.cu();
                break;
            case GeographicContourLineSeries.$$p[2]:
                this.xy.cv();
                break;
            case GeographicContourLineSeries.$$p[3]:
                this.xu.yu = this.xt;
                break;
            case "DashArray":
                this.xu.v4 = this.v4;
                break;
            case "DashCap":
                this.xu.v5 = this.v5;
                break;
            case "MiterLimit":
                this.xu.jh = this.jh;
                break;
            case "LineJoin":
                this.xu.v7 = this.v7;
                break;
        }
    };
    GeographicContourLineSeries.$t = markType(GeographicContourLineSeries, 'GeographicContourLineSeries', GeographicXYTriangulatingSeries.$);
    GeographicContourLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicContourLineSeries, 'raisePropertyChanged', ['ActualFillScale:xw:x6', [ValueBrushScale.$, null], 'FillScale:xx:x7', [ValueBrushScale.$, null], 'ValueMemberPath:x1:x8', [2, "value"], 'ValueResolver:xt:x9', [ContourValueResolver.$, null]]);
    return GeographicContourLineSeries;
}(GeographicXYTriangulatingSeries));
export { GeographicContourLineSeries };
