/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HostSeriesView } from "./HostSeriesView";
import { HighDensityScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { Color } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { typeCast, markType, runOn, delegateCombine, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicHighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicHighDensityScatterSeriesView, _super);
    function GeographicHighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cl = null;
        _this.cl = a;
        return _this;
    }
    GeographicHighDensityScatterSeriesView.prototype.b9 = function () {
        _super.prototype.b9.call(this);
        var a = typeCast(HighDensityScatterSeries.$, this.cl.w2);
        a.zb = this.cl.xr;
        a.zj = this.cl.xp;
        a.xo = this.cl.xe;
        a.xn = this.cl.xd;
        a.f8 = this.cl.xc;
        a.yj = this.cl.xg;
        a.yi = this.cl.xf;
        a.aah = this.cl.ya;
        a.aag = this.cl.x9;
        a.yv = this.cl.xj;
    };
    GeographicHighDensityScatterSeriesView.prototype.cr = function () {
        this.cl.w2.zb = this.cl.xr;
    };
    GeographicHighDensityScatterSeriesView.prototype.cq = function () {
        this.cl.w2.zj = this.cl.xp;
    };
    GeographicHighDensityScatterSeriesView.prototype.cw = function () {
        this.cl.w2.xo = this.cl.xe;
    };
    GeographicHighDensityScatterSeriesView.prototype.cu = function () {
        this.cl.w2.xn = this.cl.xd;
    };
    GeographicHighDensityScatterSeriesView.prototype.cs = function () {
        this.cl.w2.f8 = this.cl.xc;
    };
    GeographicHighDensityScatterSeriesView.prototype.cp = function () {
        this.cl.w2.yj = this.cl.xg;
    };
    GeographicHighDensityScatterSeriesView.prototype.cn = function () {
        this.cl.w2.yi = this.cl.xf;
    };
    GeographicHighDensityScatterSeriesView.prototype.cv = function () {
        var a = typeCast(HighDensityScatterSeries.$, this.cl.w2);
        if (this.cl.dc == null) {
            a.w7 = null;
            a.w9 = null;
            return;
        }
        a.w7 = this.cl.dc.wv;
        a.w9 = this.cl.dc.wx;
    };
    GeographicHighDensityScatterSeriesView.prototype.cx = function () {
        this.cl.w2.w7 = this.cl.dc.wv;
    };
    GeographicHighDensityScatterSeriesView.prototype.cy = function () {
        this.cl.w2.w9 = this.cl.dc.wx;
    };
    GeographicHighDensityScatterSeriesView.prototype.co = function () {
        this.cl.w2.aah = this.cl.ya;
    };
    GeographicHighDensityScatterSeriesView.prototype.cm = function () {
        this.cl.w2.aag = this.cl.x9;
    };
    GeographicHighDensityScatterSeriesView.prototype.ct = function () {
        this.cl.w2.yv = this.cl.xj;
    };
    GeographicHighDensityScatterSeriesView.prototype.ax = function () {
        _super.prototype.ax.call(this);
        if (!this.r) {
            this.cl.ya = Defaults.aq;
            this.cl.x9 = Defaults.ap;
            this.cl.vh = Defaults.al;
            this.cl.vx = Defaults.ak;
        }
    };
    GeographicHighDensityScatterSeriesView.$t = markType(GeographicHighDensityScatterSeriesView, 'GeographicHighDensityScatterSeriesView', HostSeriesView.$);
    return GeographicHighDensityScatterSeriesView;
}(HostSeriesView));
export { GeographicHighDensityScatterSeriesView };
/**
 * @hidden
 */
var GeographicHighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicHighDensityScatterSeries, _super);
    function GeographicHighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.xa = null;
        _this.progressiveLoadStatusChanged = null;
        _this.xi = 0;
        _this.ab = GeographicHighDensityScatterSeries.$;
        return _this;
    }
    GeographicHighDensityScatterSeries.prototype.bk = function () {
        return new GeographicHighDensityScatterSeries();
    };
    GeographicHighDensityScatterSeries.prototype.jk = function () {
        if (!isNaN_(this.jj)) {
            return _super.prototype.jk.call(this);
        }
        return Defaults.q;
    };
    GeographicHighDensityScatterSeries.prototype.get_fo = function () {
        return true;
    };
    GeographicHighDensityScatterSeries.prototype.ct = function () {
        return new GeographicHighDensityScatterSeriesView(this);
    };
    GeographicHighDensityScatterSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.xb = a;
    };
    GeographicHighDensityScatterSeries.prototype.w1 = function () {
        this.xa = new HighDensityScatterSeries();
        return this.xa;
    };
    Object.defineProperty(GeographicHighDensityScatterSeries.prototype, "xk", {
        get: function () {
            return this.xi;
        },
        set: function (a) {
            var b = this.xi;
            this.xi = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.xi);
        },
        enumerable: false,
        configurable: true
    });
    GeographicHighDensityScatterSeries.prototype.w7 = function (a, b) {
        _super.prototype.w7.call(this, a, b);
        var c = this.w2;
        c.progressiveLoadStatusChanged = delegateCombine(c.progressiveLoadStatusChanged, runOn(this, this.xy));
        var d = this.w2;
        d.propertyUpdated = delegateCombine(d.propertyUpdated, runOn(this, this.xx));
    };
    GeographicHighDensityScatterSeries.prototype.xy = function (a, b) {
        this.xk = b.currentStatus;
        if (this.progressiveLoadStatusChanged != null) {
            this.progressiveLoadStatusChanged(this, b);
        }
    };
    GeographicHighDensityScatterSeries.prototype.xx = function (a, b) {
        if (this.xa == null) {
            return;
        }
    };
    GeographicHighDensityScatterSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.xb.cv();
                break;
            case GeographicHighDensityScatterSeries.$$p[5]:
                this.xb.cr();
                break;
            case GeographicHighDensityScatterSeries.$$p[4]:
                this.xb.cq();
                break;
            case GeographicHighDensityScatterSeries.$$p[9]:
                this.xb.cw();
                break;
            case GeographicHighDensityScatterSeries.$$p[8]:
                this.xb.cu();
                break;
            case GeographicHighDensityScatterSeries.$$p[6]:
                this.xb.cs();
                break;
            case "XAxis":
                this.xb.cx();
                break;
            case "YAxis":
                this.xb.cy();
                break;
            case GeographicHighDensityScatterSeries.$$p[3]:
                this.xb.cp();
                break;
            case GeographicHighDensityScatterSeries.$$p[1]:
                this.xb.cn();
                break;
            case GeographicHighDensityScatterSeries.$$p[2]:
                this.xb.co();
                break;
            case GeographicHighDensityScatterSeries.$$p[0]:
                this.xb.cm();
                break;
            case GeographicHighDensityScatterSeries.$$p[7]:
                this.xb.ct();
                break;
        }
    };
    GeographicHighDensityScatterSeries.prototype.get_g7 = function () {
        return true;
    };
    GeographicHighDensityScatterSeries.prototype.set_g7 = function (a) {
        _super.prototype.set_g7.call(this, a);
    };
    GeographicHighDensityScatterSeries.$t = markType(GeographicHighDensityScatterSeries, 'GeographicHighDensityScatterSeries', GeographicMapSeriesHost.$);
    GeographicHighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicHighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:x9:xz', [Color.$, Defaults.ap], 'HeatMaximum:xf:x0', [1, 50], 'HeatMinimumColor:ya:x1', [Color.$, Defaults.aq], 'HeatMinimum:xg:x2', [1, 0], 'LatitudeMemberPath:xp:x3', [2, null], 'LongitudeMemberPath:xr:x4', [2, null], 'MouseOverEnabled:xc:x5', [0, false], 'PointExtent:xj:x6', [1, 1], 'ProgressiveLoad:xd:x7', [0, true], 'UseBruteForce:xe:x8', [0, false]]);
    return GeographicHighDensityScatterSeries;
}(GeographicMapSeriesHost));
export { GeographicHighDensityScatterSeries };
