/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { MapResizeBehavior_$type } from "./MapResizeBehavior";
import { MapBackgroundTilingMode_$type } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-webcomponents-core";
import { Base, Boolean_$type, typeCast, enumGetBox, Point_$type, fromEnum, Number_$type, runOn, delegateRemove, delegateCombine, markType, markDep, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, IEnumerable_$type } from "igniteui-webcomponents-core";
import { NumericXAxis } from "igniteui-webcomponents-charts";
import { NumericYAxis } from "igniteui-webcomponents-charts";
import { SphericalMercatorVerticalScaler } from "./SphericalMercatorVerticalScaler";
import { Control } from "igniteui-webcomponents-core";
import { SphericalMercatorHorizontalScaler } from "./SphericalMercatorHorizontalScaler";
import { ScalerParams } from "igniteui-webcomponents-charts";
import { SeriesViewerView } from "igniteui-webcomponents-charts";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { MathUtil } from "igniteui-webcomponents-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { ItfConverter } from "igniteui-webcomponents-core";
import { ChartVisualData } from "igniteui-webcomponents-charts";
import { RectData } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-webcomponents-core";
import { XamMultiScaleImage } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ScatterAreaSeries } from "igniteui-webcomponents-charts";
import { BrushCollection } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { OpenStreetMapTileSource } from "igniteui-webcomponents-core";
import { ColorScale } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
var XamGeographicMap = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamGeographicMap, _super);
    function XamGeographicMap() {
        var _this = _super.call(this) || this;
        _this.xk = null;
        _this.w9 = false;
        _this.w1 = 1;
        _this.xg = 0;
        _this.yr = null;
        _this.wy = null;
        _this.wu = null;
        _this.ww = null;
        _this.w0 = null;
        _this.yn = { $type: Point_$type, x: NaN, y: NaN };
        _this.yu = null;
        _this.xf = 1;
        _this.imageTilesReady = null;
        _this.w8 = null;
        _this.yt = Rect.empty;
        _this.xg = SphericalMercatorVerticalScaler.am(XamGeographicMap.ys.bottom) - SphericalMercatorVerticalScaler.am(XamGeographicMap.ys.top);
        _this.ab = XamGeographicMap.$;
        _this.backgroundContent = new OpenStreetMapImagery();
        var a = ((function () {
            var $ret = new NumericXAxis();
            $ret.bi = _this;
            return $ret;
        })());
        a.cf = true;
        _this.wv = a;
        _this.wv.n4 = new SphericalMercatorHorizontalScaler();
        var b = ((function () {
            var $ret = new NumericYAxis();
            $ret.bi = _this;
            return $ret;
        })());
        b.cf = true;
        _this.wx = b;
        _this.wx.n4 = new SphericalMercatorVerticalScaler();
        _this.x2();
        _this.x9();
        _this.n1();
        return _this;
    }
    XamGeographicMap.prototype.provideContainer = function (a) {
        _super.prototype.provideContainer.call(this, a);
        this.wv.provideRenderer(a);
        this.wx.provideRenderer(a);
    };
    XamGeographicMap.prototype.n1 = function () {
        _super.prototype.n1.call(this);
        this.w7.fv(this.hj);
    };
    XamGeographicMap.prototype.fk = function () {
        return this.xd;
    };
    XamGeographicMap.prototype.fl = function () {
        return this.xd;
    };
    XamGeographicMap.prototype.w4 = function () {
        if (this.w2 == 0) {
            if (this.w9) {
                return 2;
            }
        }
        return 1;
    };
    Object.defineProperty(XamGeographicMap.prototype, "w3", {
        get: function () {
            return this.w1;
        },
        set: function (a) {
            this.w1 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "yw", {
        get: function () {
            return this.yr;
        },
        set: function (a) {
            var b = Rect.l_op_Inequality(this.yr, a);
            if (b) {
                var c = this.yr;
                this.yr = a;
                this.qn("ActualWorldRect", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.y0 = function () {
        return this.yw;
    };
    XamGeographicMap.prototype.x2 = function () {
        if (this.y8.isEmpty) {
            return;
        }
        this.yw = this.y6(this.y8, this.cr == 1);
    };
    XamGeographicMap.prototype.y6 = function (a, b) {
        var c = a.top;
        var d = a.left;
        var e = a.width;
        var f = a.height;
        var g = SphericalMercatorVerticalScaler.am(a.bottom);
        var h = SphericalMercatorVerticalScaler.am(a.top);
        var i = g - h;
        var j = a.width / XamGeographicMap.ys.width;
        var k = SphericalMercatorVerticalScaler.am(XamGeographicMap.ys.top);
        var l = i / j;
        if (i / j > this.xg) {
            var m = i / this.xg;
            var n = m - j;
            d = d - (n / 2) * XamGeographicMap.ys.width;
            e = m * XamGeographicMap.ys.width;
            if (b) {
                if (d < XamGeographicMap.ys.left) {
                    d += (XamGeographicMap.ys.left - d);
                }
                else if ((d + e) > XamGeographicMap.ys.right) {
                    d -= ((d + e) - XamGeographicMap.ys.right);
                }
            }
        }
        else if (i / j < this.xg) {
            var o = this.xg * j;
            var p = o - i;
            var q = h - (p / 2);
            var r = g + (p / 2);
            if (b) {
                if (q < k) {
                    q += (k - q);
                    r += (k - q);
                }
                else if (r > (k + this.xg)) {
                    q -= ((r) - (k + this.xg));
                    r -= ((r) - (k + this.xg));
                }
            }
            c = SphericalMercatorVerticalScaler.aq(q);
            f = SphericalMercatorVerticalScaler.aq(r) - c;
        }
        var s = new Rect(0, d, c, e, f);
        return s;
    };
    Object.defineProperty(XamGeographicMap.prototype, "backgroundContent", {
        get: function () {
            return this.wy;
        },
        set: function (a) {
            var b = a != this.backgroundContent;
            if (b) {
                var c = this.backgroundContent;
                this.wy = a;
                this.qn("BackgroundContent", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "wv", {
        get: function () {
            return this.wu;
        },
        set: function (a) {
            var b = a != this.wv;
            if (b) {
                var c = this.wv;
                this.wu = a;
                this.qn("XAxis", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "wx", {
        get: function () {
            return this.ww;
        },
        set: function (a) {
            var b = a != this.wx;
            if (b) {
                var c = this.wx;
                this.ww = a;
                this.qn("YAxis", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.getZoomRectFromGeoRect = function (a) {
        return this.getZoomFromGeographicRect(a);
    };
    XamGeographicMap.prototype.yc = function (a) {
        this.wo = a;
    };
    XamGeographicMap.prototype.yb = function (a) {
        this.y8 = a;
    };
    XamGeographicMap.prototype.getZoomFromGeographicRect = function (a) {
        return this.yy(a, true, 0);
    };
    XamGeographicMap.prototype.yx = function (a, b) {
        return this.yy(a, false, b);
    };
    XamGeographicMap.prototype.yy = function (a, b, c) {
        var d = a;
        if (b) {
            d = this.y6(a, false);
        }
        var e = this.wv;
        var f = this.wx;
        var g = new ScalerParams(1, XamGeographicMap.yv, this.wn, e.ch);
        g.c = this.v9;
        var h = new ScalerParams(1, XamGeographicMap.yv, this.wn, f.ch);
        h.c = this.v9;
        var i = this.wv.el(d.left, g);
        var j = this.wv.el(d.right, g);
        var k = this.wx.el(d.top, h);
        var l = this.wx.el(d.bottom, h);
        var m = (i - c) / this.wn.width;
        var n = (l - c) / this.wn.height;
        var o = (j - i + (c * 2)) / this.wn.width;
        var p = (k - l + (c * 2)) / this.wn.height;
        var q = new Rect(0, m, n, o, p);
        q.intersect(XamGeographicMap.yv);
        if (q.isEmpty) {
            q = XamGeographicMap.yv;
        }
        return q;
    };
    XamGeographicMap.prototype.getZoomFromGeographicPoints = function (a, b) {
        var c = a.x;
        var d = b.y;
        var e = b.x - a.x;
        var f = a.y - b.y;
        if (e < 0 || f < 0) {
            return XamGeographicMap.yv;
        }
        else {
            var g = new Rect(0, c, d, e, f);
            return this.getZoomFromGeographicRect(g);
        }
    };
    XamGeographicMap.prototype.y2 = function (a) {
        var b = this.wv;
        var c = this.wx;
        var d = new ScalerParams(1, a, this.wn, b.ch);
        d.c = this.v9;
        var e = new ScalerParams(1, a, this.wn, c.ch);
        e.c = this.v9;
        var f = this.v8;
        var g = b.eo(f.left, d);
        var h = c.eo(f.top, e);
        var i = b.eo(f.right, d);
        var j = c.eo(f.bottom, e);
        var k = i - g;
        var l = h - j;
        var m = new Rect(0, g, j, k, l);
        if (this.cr == 1) {
            m.intersect(XamGeographicMap.ys);
            if (m.isEmpty) {
                m = XamGeographicMap.ys;
            }
        }
        return m;
    };
    XamGeographicMap.prototype.yo = function (a) {
        var b = this.wv.mf(a.x);
        var c = this.wx.mf(a.y);
        return { $type: Point_$type, x: b, y: c };
    };
    XamGeographicMap.prototype.yp = function (a) {
        var b = this.wv.e6(a.x);
        var c = this.wx.e6(a.y);
        return { $type: Point_$type, x: b, y: c };
    };
    XamGeographicMap.prototype.yq = function (a) {
        return this.yp(a);
    };
    XamGeographicMap.prototype.xz = function () {
        var a = typeCast(GeographicMapImagery.$, this.backgroundContent);
        if (a != null) {
            a.clearTileCache();
        }
    };
    XamGeographicMap.prototype.x5 = function (a) {
    };
    XamGeographicMap.prototype.gf = function () {
        return true;
    };
    XamGeographicMap.prototype.x7 = function () {
        var e_1, _a;
        this.w7.ee();
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.se();
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    XamGeographicMap.prototype.ya = function () {
        if (this.w6 == 2) {
            if (!this.wn.isEmpty && this.wn.width > 0 && this.wn.height > 0) {
                var a = this.wv.mf(this.wn.left + (this.wn.width / 2));
                var b = this.wx.mf(this.wn.top + (this.wn.height / 2));
                this.yn = { $type: Point_$type, x: a, y: b };
            }
        }
        else {
            if (!this.wn.isEmpty && this.wn.width > 0 && this.wn.height > 0) {
                var c = this.wv.mf(this.wn.left);
                var d = this.wx.mf(this.wn.top);
                this.yn = { $type: Point_$type, x: c, y: d };
            }
        }
    };
    XamGeographicMap.prototype.x6 = function () {
        if (isNaN_(this.yn.x) || isNaN_(this.yn.y)) {
            this.ya();
        }
        var a = this.yn.x;
        var b = this.yn.y;
        if (!isNaN_(a) && !isNaN_(b)) {
            var c = this.v5.left;
            var d = this.v5.top;
            var e = this.v5.width;
            var f = this.v5.height;
            if (e > this.yu.width) {
            }
            else {
                var g = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wv.ch);
                g.c = this.v9;
                var h = this.wv.el(a, g);
                if (this.w6 == 2) {
                    var i = h / this.wn.width;
                    c = i - (e / 2);
                }
                else {
                    c = h / this.wn.width;
                }
                if (c + e > this.yu.right) {
                    c = this.yu.right - e;
                }
                else if (c < this.yu.left) {
                    c = this.yu.left;
                }
            }
            if (f > this.yu.height) {
            }
            else {
                var j = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wx.ch);
                j.c = this.v9;
                var k = this.wx.el(b, j);
                if (this.w6 == 2) {
                    var l = k / this.wn.height;
                    d = l - (f / 2);
                }
                else {
                    d = k / this.wn.height;
                }
                if (d + f > this.yu.bottom) {
                    d = this.yu.bottom - f;
                }
                else if (d < this.yu.top) {
                    d = this.yu.top;
                }
            }
            this.ry(new Rect(0, c, d, e, f), false);
        }
    };
    XamGeographicMap.prototype.get_fc = function () {
        return true;
    };
    XamGeographicMap.prototype.v6 = function () {
        var a = _super.prototype.v6.call(this);
        if (this.wv == null || this.wx == null) {
            return a;
        }
        this.wh();
        var b = a.left;
        var c = a.top;
        if (this.cr == 1) {
            if (this.wo.width > this.yu.width) {
                b = 0.5 - (this.wo.width / 2);
            }
            else if (b + a.width > this.yu.right) {
                b = this.yu.right - this.wo.width;
            }
            else if (b < this.yu.left) {
                b = this.yu.left;
            }
            if (this.wo.height > this.yu.height) {
                c = 0.5 - (this.wo.height / 2);
            }
            else if (c + this.wo.height > this.yu.bottom) {
                c = this.yu.bottom - this.wo.height;
            }
            else if (c < this.yu.top) {
                c = this.yu.top;
            }
        }
        var d = false;
        if (!this.xc && this.cr == 2 && this.w9) {
            if (b > 1) {
                b = (b - Math.floor(b)) + 1;
            }
            if (b < 0) {
                b = 0 - (Math.ceil(b) - b);
            }
            if ((a.right - this.yu.right) > 0 && ((a.right - this.yu.right) / a.width) > 0.8) {
                b = this.yu.left - (a.width - (a.right - this.yu.right));
                d = true;
            }
            else if (a.left < this.yu.left && (Math.abs(a.left - this.yu.left) / a.width) > 0.8) {
                b = this.yu.right - (Math.abs(a.left - this.yu.left));
                d = true;
            }
        }
        var e = new Rect(0, b, c, a.width, a.height);
        if (this.xc) {
            var f = this.yx(this.y8, 1);
            f = this.yz(f);
            var g = e.left + e.width / 2;
            var h = e.top + e.height / 2;
            if (e.width > f.width) {
                var i = e.height / e.width;
                var j = f.width;
                var k = i * j;
                e = new Rect(0, g - j / 2, h - k / 2, j, k);
                d = true;
            }
            if (e.height > f.height) {
                var l = e.width / e.height;
                var m = f.height;
                var n = l * m;
                e = new Rect(0, g - n / 2, h - m / 2, n, m);
                d = true;
            }
            if (e.left < f.left) {
                e = new Rect(0, f.left, e.top, e.width, e.height);
                d = true;
            }
            if (e.top < f.top) {
                e = new Rect(0, e.left, f.top, e.width, e.height);
                d = true;
            }
            if (e.right > f.right) {
                e = new Rect(0, f.right - e.width, e.top, e.width, e.height);
                d = true;
            }
            if (e.bottom > f.bottom) {
                e = new Rect(0, e.left, f.bottom - e.height, e.width, e.height);
                d = true;
            }
        }
        if (d) {
            this.ey = true;
            this.wo = e;
            this.ey = false;
        }
        return e;
    };
    XamGeographicMap.prototype.m5 = function (a, b) {
        var c = true;
        var d = true;
        var e = 0;
        var f = this.wh();
        var g = 0;
        var h = 0;
        if ((a.right - f.right) > 0) {
            g = ((a.right - f.right) / a.width);
        }
        if (a.left < f.left) {
            h = (Math.abs(a.left - f.left) / a.width);
        }
        if (h == 0 && g == 0) {
            c = false;
        }
        if (h > g) {
            d = false;
        }
        if (c) {
            if (d) {
                var i = this.wu.el(-180, b);
                var j = this.wu.el(180, b);
                e = j - i;
            }
            else {
                var k = this.wu.el(-180, b);
                var l = this.wu.el(180, b);
                e = k - l;
            }
        }
        return new Tuple$2(Boolean_$type, Number_$type, c, e);
    };
    XamGeographicMap.prototype.wh = function () {
        var a = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wv.ch);
        a.c = this.v9;
        var b = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wx.ch);
        b.c = this.v9;
        var c = this.wv.el(XamGeographicMap.ys.left, a);
        var d = this.wv.el(XamGeographicMap.ys.right, a);
        var e = this.wx.el(XamGeographicMap.ys.top, b);
        var f = this.wx.el(XamGeographicMap.ys.bottom, b);
        this.yu = new Rect(0, c / this.wn.width, f / this.wn.height, (d - c) / this.wn.width, (e - f) / this.wn.height);
        return this.yu;
    };
    XamGeographicMap.prototype.yz = function (a) {
        var b = this.hn;
        var c = 0.5 * (a.left + a.right);
        var d = 0.5 * (a.top + a.bottom);
        var e = a.width;
        var f = a.height;
        var g = MathUtil.d(a.width, b, 1);
        var h = MathUtil.d(a.height, b, 1);
        var i = this.wn;
        var j = i.width / i.height;
        var k = g * i.width;
        var l = h * i.height;
        var m = k / l;
        if (m != j) {
            if (l * j > k) {
                k = l * j;
                g = k / i.width;
            }
            else {
                l = k / j;
                h = l / i.height;
            }
        }
        var n = g != e;
        var o = h != f;
        var p = n ? c - 0.5 * g : a.left;
        var q = o ? d - 0.5 * h : a.top;
        var r = n ? c + 0.5 * g : a.right;
        var s = o ? d + 0.5 * h : a.bottom;
        if (p < 0) {
            p = 0;
            r = p + g;
        }
        if (r > 1) {
            r = 1;
            p = r - g;
        }
        if (q < 0) {
            q = 0;
            s = q + h;
        }
        if (s > 1) {
            s = 1;
            q = s - h;
        }
        return new Rect(0, p, q, r - p, s - q);
    };
    XamGeographicMap.prototype.v7 = function (a) {
        _super.prototype.v7.call(this, this.wn);
        if (a.isEmpty) {
            return Rect.empty;
        }
        var b;
        if (a.width > a.height) {
            var c = intDivide(truncate((a.width - a.height)), 2);
            b = new Rect(0, a.left + c, a.top, a.height, a.height);
        }
        else {
            var d = intDivide(truncate((a.height - a.width)), 2);
            b = new Rect(0, a.left, a.top + d, a.width, a.width);
        }
        return b;
    };
    XamGeographicMap.prototype.y1 = function (a) {
        return this.v7(a);
    };
    XamGeographicMap.prototype.c8 = function () {
        return new XamGeographicMapView(this);
    };
    XamGeographicMap.prototype.x1 = function (a) {
        if (a != null) {
            a.bi = this;
        }
    };
    XamGeographicMap.prototype.p6 = function (a) {
        _super.prototype.p6.call(this, a);
        this.w7 = a;
    };
    XamGeographicMap.prototype.qh = function (a, b) {
        _super.prototype.qh.call(this, a, b);
        this.rm(this.wv);
        this.rm(this.wx);
        if (Rect.l_op_Inequality(a, b)) {
            this.x6();
        }
        if (this.xc) {
            this.v5 = this.v6();
        }
        this.yd();
    };
    Object.defineProperty(XamGeographicMap.prototype, "xh", {
        get: function () {
            return this.xf;
        },
        set: function (a) {
            var b = this.xf;
            this.xf = a;
            this.qn("ActualWindowScale", b, this.xf);
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.ht = function () {
        return this.xh;
    };
    XamGeographicMap.prototype.hu = function () {
        return this.xh;
    };
    XamGeographicMap.prototype.rl = function () {
        _super.prototype.rl.call(this);
        var a = Math.min(this.v5.width, this.v5.height);
        this.xh = a;
    };
    XamGeographicMap.prototype.f3 = function () {
        return this.w9;
    };
    XamGeographicMap.prototype.cs = function () {
        if (this.ct == 0) {
            if (this.xa) {
                return 2;
            }
        }
        return this.ct;
    };
    XamGeographicMap.prototype.qi = function (a, b, c, d) {
        var e_2, _a, e_3, _b;
        _super.prototype.qi.call(this, a, b, c, d);
        switch (b) {
            case "ZoomCoercionMode":
                this.x2();
                break;
            case "WindowRect":
                this.ya();
                break;
            case XamGeographicMap.$$p[0]:
                this.w3 = this.w4();
                if (this.w0 != null) {
                    this.w0.isHorizontalWrappingEnabled = this.w3 == 2;
                }
                break;
            case XamGeographicMap.$$p[1]:
                this.w9 = this.xa;
                this.w3 = this.w4();
                this.cr = this.cs();
                if (this.w0 != null) {
                    this.w0.isHorizontalWrappingEnabled = this.w3 == 2;
                }
                break;
            case XamGeographicMap.$$p[4]:
                this.v5 = this.v6();
                break;
            case "BackgroundContent":
                if (this.w0 != null) {
                    var e = this.w0;
                    e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.x3));
                    this.w0.deferralHandler = null;
                }
                this.w0 = typeCast(GeographicMapImagery.$, this.backgroundContent);
                if (this.w0 != null) {
                    var f = this.w0;
                    f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.x3));
                    this.w0.deferralHandler = this;
                    this.w0.isHorizontalWrappingEnabled = this.w3 == 2;
                }
                this.w7.fu(typeCast(GeographicMapImagery.$, c), typeCast(GeographicMapImagery.$, d));
                if (this.w0 != null) {
                    this.w0.geographicMap = this;
                    this.w7.fr(this.v5);
                    this.w7.fv(this.hj);
                }
                break;
            case "YAxis":
            case "XAxis":
                this.x8(c);
                this.x1(d);
                break;
            case XamGeographicMap.$$p[6]:
                if (!this.xb) {
                    this.wo = XamGeographicMap.yv;
                }
                this.x2();
                this.x9();
                this.ya();
                this.v5 = this.v6();
                this.w7.fs();
                break;
            case "ActualWindowRect":
                this.w7.fr(this.v5);
                break;
            case "ActualWorldRect":
                try {
                    for (var _c = __values(fromEnum(this.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var g = _d.value;
                        g.rs(false);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                break;
            case XamGeographicMap.$$p[5]:
                this.xh = this.xi;
                break;
            case "ActualWindowScale":
                if (!this.gb) {
                    this.rw(this.ht(), this.hu());
                }
                break;
            case "ActualPixelScalingRatio":
                this.w7.fv(this.hj);
                break;
            case "WindowRectMinWidth":
            case "WindowRectMinHeight":
                var h = d;
                if (isNaN_(h) || isInfinity(h)) {
                    this.hn = 5E-06;
                    this.hm = 5E-06;
                }
                else {
                    this.hn = h;
                    this.hm = h;
                }
                break;
            case XamGeographicMap.$$p[7]:
                this.rs();
                break;
            case "MarkerAutomaticBehavior":
                try {
                    for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var i = _f.value;
                        i.qg();
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                break;
        }
    };
    XamGeographicMap.prototype.x3 = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    XamGeographicMap.prototype.x8 = function (a) {
        if (a != null) {
            a.bi = null;
        }
    };
    XamGeographicMap.prototype.x9 = function () {
        if (this.wv != null) {
            this.wv.mc = this.yw.left;
            this.wv.mb = this.yw.right;
        }
        if (this.wx != null) {
            this.wx.mc = this.yw.top;
            this.wx.mb = this.yw.bottom;
        }
        this.wv.c2(true);
        this.wx.c2(true);
    };
    XamGeographicMap.prototype.getFontInfo = function () {
        this.w8 = this.w7.fo;
        return this.w8;
    };
    XamGeographicMap.prototype.u9 = function () {
        return this.w7.fw;
    };
    XamGeographicMap.prototype.getFontBrush = function () {
        return this.w7.fx;
    };
    XamGeographicMap.prototype.re = function (a, b) {
        if (typeCast(ItfConverter.$, b) !== null) {
            var c = b;
            var d = a;
            d.itemsSource = c.triangulationSource.points;
            d.xb = c.triangulationSource.triangles;
        }
        else {
            _super.prototype.re.call(this, a, b);
        }
    };
    XamGeographicMap.prototype.register = function (a, b) {
        this.q2(a, b);
    };
    XamGeographicMap.prototype.unRegister = function (a) {
        this.rk(a);
    };
    XamGeographicMap.prototype.deferredRefresh = function () {
        this.nj();
    };
    XamGeographicMap.prototype.deferAction = function (a) {
        if (this.xk != null) {
            this.xk.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    XamGeographicMap.prototype.x0 = function (a) {
        this.rr(a);
    };
    XamGeographicMap.prototype.xl = function () {
        var a = new ChartVisualData();
        var b = this.wv.fy();
        var c = this.wx.fy();
        a.axes.add1(b);
        a.axes.add1(c);
        for (var d = 0; d < this.series.count; d++) {
            var e = this.series._inner[d].km();
            a.series.add1(e);
        }
        a.name = this.name;
        a.contentArea = RectData.b(this.wn);
        a.centralArea = RectData.b(this.wn);
        a.plotArea = RectData.b(this.wn);
        return a;
    };
    XamGeographicMap.prototype.wd = function (a, b, c) {
        return a;
    };
    XamGeographicMap.prototype.x4 = function () {
    };
    Object.defineProperty(XamGeographicMap.prototype, "y7", {
        get: function () {
            return this.yt;
        },
        set: function (a) {
            this.yt = a;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.ye = function (a) {
        this.y7 = a;
        this.yd();
    };
    XamGeographicMap.prototype.yd = function () {
        if (this.xe && !this.y7.isEmpty) {
            var a = this.getZoomFromGeographicRect(this.y7);
            this.y7 = Rect.empty;
            this.ry(a, false);
        }
    };
    Object.defineProperty(XamGeographicMap.prototype, "xe", {
        get: function () {
            return !this.wn.isEmpty && !this.v9.isEmpty;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.$t = markType(XamGeographicMap, 'XamGeographicMap', SeriesViewer.$, [IMapRenderDeferralHandler_$type]);
    XamGeographicMap.w5 = 0;
    XamGeographicMap.ys = new Rect(2, { $type: Point_$type, x: -180, y: -85.05112878 }, { $type: Point_$type, x: 180, y: 85.05112878 });
    XamGeographicMap.yv = new Rect(0, 0, 0, 1, 1);
    XamGeographicMap.$$p = markDep(DependencyProperty, PropertyMetadata, XamGeographicMap, 'qn', ['BackgroundTilingMode:w2:yf', [MapBackgroundTilingMode_$type, enumGetBox(MapBackgroundTilingMode_$type, 0)], 'IsHorizontalWrappingEnabled:xa:yg', [0, false], 'ResizeBehavior:w6:yh', [MapResizeBehavior_$type, enumGetBox(MapResizeBehavior_$type, XamGeographicMap.w5)], 'SuppressZoomResetOnWorldRectChange:xb:yi', [0, false], 'UseWorldRectForZoomBounds:xc:yj', [0, false], 'WindowScale:xi:yk', [1, NaN], 'WorldRect:y8:yl', [Rect.$, XamGeographicMap.ys], 'Zoomable:xd:ym', [0, true]]);
    return XamGeographicMap;
}(SeriesViewer));
export { XamGeographicMap };
/**
 * @hidden
 */
var GeographicMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapImagery, _super);
    function GeographicMapImagery(a) {
        var _this = _super.call(this) || this;
        _this.ak = null;
        _this.imageTilesReady = null;
        _this.an = null;
        _this.ap = null;
        _this.propertyChanged = null;
        _this.imagesChanged = null;
        _this.cancellingImage = null;
        _this.downloadingImage = null;
        _this.ab = GeographicMapImagery.$;
        _this.ap = a;
        _this.aj = _this.ai();
        _this.bb(_this.aj);
        return _this;
    }
    GeographicMapImagery.prototype.bb = function (a) {
    };
    GeographicMapImagery.prototype.ai = function () {
        return new GeographicMapImageryView(this);
    };
    Object.defineProperty(GeographicMapImagery.prototype, "deferralHandler", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            this.ak = a;
            if (this.ao != null) {
                this.ao.al = a;
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.prototype.a5 = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    GeographicMapImagery.prototype.a9 = function () {
        var a = this.ao;
        a.imageTilesReady = delegateCombine(a.imageTilesReady, runOn(this, this.a5));
        this.ao.al = this.deferralHandler;
        var b = this.ao;
        b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.a4));
        var c = this.ao;
        c.downloadingImage = delegateCombine(c.downloadingImage, runOn(this, this.a3));
        var d = this.ao;
        d.cancellingImage = delegateCombine(d.cancellingImage, runOn(this, this.a2));
        this.ao.bf = this.referer;
        this.ao.bj = this.userAgent;
        this.ao.av = this.isHorizontalWrappingEnabled;
    };
    GeographicMapImagery.prototype.a3 = function (a, b) {
        if (this.downloadingImage != null) {
            this.downloadingImage(this, b);
        }
    };
    GeographicMapImagery.prototype.a2 = function (a, b) {
        if (this.cancellingImage != null) {
            this.cancellingImage(this, b);
        }
    };
    GeographicMapImagery.prototype.bg = function () {
        if (this.ao != null) {
            this.aj.e();
        }
    };
    GeographicMapImagery.prototype.ba = function (a, b, c) {
        switch (a) {
            case GeographicMapImagery.$$p[3]:
                this.bg();
                break;
            case "GeographicMap":
                this.aj.e();
                break;
            case GeographicMapImagery.$$p[1]:
                if (this.ao != null) {
                    this.ao.bf = this.referer;
                }
                break;
            case GeographicMapImagery.$$p[2]:
                if (this.ao != null) {
                    this.ao.bj = this.userAgent;
                }
                break;
            case GeographicMapImagery.$$p[0]:
                if (this.ao != null) {
                    this.ao.av = this.isHorizontalWrappingEnabled;
                }
                break;
        }
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    Object.defineProperty(GeographicMapImagery.prototype, "geographicMap", {
        get: function () {
            return this.c(GeographicMapImagery.geographicMapProperty);
        },
        set: function (a) {
            this.h(GeographicMapImagery.geographicMapProperty, a);
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.a8 = function (a, b) {
        a.a7(b.oldValue, b.newValue);
    };
    GeographicMapImagery.prototype.a7 = function (a, b) {
        this.ba("GeographicMap", a, b);
    };
    GeographicMapImagery.prototype.clearTileCache = function () {
        if (this.ao != null) {
            this.ao.bs(0, 0, 0, 0);
        }
    };
    Object.defineProperty(GeographicMapImagery.prototype, "ao", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            this.an = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("MultiScaleImage"));
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.prototype.bn = function (a) {
        if (this.geographicMap == null || a.width < 1 || a.height < 1) {
            return a;
        }
        var b = new Rect(0, 0, 0, a.width, a.height);
        var c = this.geographicMap.y1(b);
        var d = XamGeographicMap.ys;
        var e = this.geographicMap.yw;
        var f = Math.min(this.windowRect.height, this.windowRect.width);
        var g = e.width / d.width;
        this.ao.a5 = (b.width / c.width) * f * g;
        var h = this.geographicMap.wv;
        var i = this.geographicMap.wx;
        var j = new ScalerParams(1, this.windowRect, b, h.ch);
        j.c = c;
        var k = new ScalerParams(1, this.windowRect, b, i.ch);
        k.c = c;
        var l = h.el(d.left, j);
        var m = i.el(d.bottom, k);
        var n = (-l / b.width) * this.ao.a5;
        var o = (-m / b.height) * this.ao.a5 * (b.height / b.width);
        this.ao.cm = { $type: Point_$type, x: n, y: o };
        return a;
    };
    GeographicMapImagery.prototype.bd = function (a) {
        this.aj.f(a);
    };
    GeographicMapImagery.prototype.bf = function (a) {
        this.aj.h(a);
    };
    GeographicMapImagery.prototype.be = function (a) {
        this.aj.g(a);
    };
    GeographicMapImagery.prototype.a4 = function (a, b) {
        if (this.imagesChanged != null) {
            this.imagesChanged(this, new ImagesChangedEventArgs());
        }
    };
    GeographicMapImagery.prototype.a6 = function () {
        this.aj.e();
    };
    GeographicMapImagery.prototype.bc = function (a) {
        this.aj.i(a);
    };
    GeographicMapImagery.prototype.v = function () {
        _super.prototype.v.call(this);
        this.ap.o = this._opacity;
    };
    GeographicMapImagery.$t = markType(GeographicMapImagery, 'GeographicMapImagery', Control.$, [INotifyPropertyChanged_$type]);
    GeographicMapImagery.geographicMapProperty = DependencyProperty.i("GeographicMap", XamGeographicMap.$, GeographicMapImagery.$, new PropertyMetadata(2, null, GeographicMapImagery.a8));
    GeographicMapImagery.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicMapImagery, 'ba', ['IsHorizontalWrappingEnabled', [0, false], 'Referer', [2, null], 'UserAgent', [2, null], 'WindowRect', [Rect.$, Rect.empty]]);
    return GeographicMapImagery;
}(Control));
export { GeographicMapImagery };
/**
 * @hidden
 */
var GeographicMapImageryView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapImageryView, _super);
    function GeographicMapImageryView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.j = null;
        _this.d = null;
        _this.b = 1;
        _this.j = Rect.empty;
        _this.a = a;
        _this.a.ao = new XamMultiScaleImage();
        _this.a.ao.ao = _this.a.ap;
        _this.a.a9();
        return _this;
    }
    GeographicMapImageryView.prototype.e = function () {
        if (this.j.isEmpty) {
            return;
        }
        this.a.bn(new Size(1, this.j.width, this.j.height));
    };
    GeographicMapImageryView.prototype.f = function (a) {
        this.a.ao.b1(a);
    };
    GeographicMapImageryView.prototype.g = function (a) {
        this.d = a;
        this.a.ao.b2(a);
    };
    GeographicMapImageryView.prototype.h = function (a) {
        this.j = a;
        this.a.ao.b3(a);
        this.a.a6();
    };
    Object.defineProperty(GeographicMapImageryView.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImageryView.prototype.i = function (a) {
        this.b = a;
        this.a.ao.bz(a);
    };
    GeographicMapImageryView.$t = markType(GeographicMapImageryView, 'GeographicMapImageryView');
    return GeographicMapImageryView;
}(Base));
export { GeographicMapImageryView };
/**
 * @hidden
 */
var GeographicXYTriangulatingSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicXYTriangulatingSeriesView, _super);
    function GeographicXYTriangulatingSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cl = null;
        _this.cl = a;
        return _this;
    }
    GeographicXYTriangulatingSeriesView.prototype.b9 = function () {
        _super.prototype.b9.call(this);
        var a = this.cl.w2;
        a.x2 = this.cl.xe;
        a.ya = this.cl.xc;
        a.trianglesSource = this.cl.xb;
        a.xq = this.cl.xh;
        a.xs = this.cl.xj;
        a.xu = this.cl.xl;
    };
    GeographicXYTriangulatingSeriesView.prototype.co = function () {
        var a = this.cl.w2;
        if (this.cl.dc == null) {
            a.w0 = null;
            a.w1 = null;
            return;
        }
        a.w0 = this.cl.dc.wv;
        a.w1 = this.cl.dc.wx;
    };
    GeographicXYTriangulatingSeriesView.prototype.cn = function () {
        this.cl.w2.x2 = this.cl.xe;
    };
    GeographicXYTriangulatingSeriesView.prototype.cm = function () {
        this.cl.w2.ya = this.cl.xc;
    };
    GeographicXYTriangulatingSeriesView.prototype.cp = function () {
        this.cl.w2.trianglesSource = this.cl.xb;
    };
    GeographicXYTriangulatingSeriesView.prototype.cq = function () {
        this.cl.w2.xq = this.cl.xh;
    };
    GeographicXYTriangulatingSeriesView.prototype.cr = function () {
        this.cl.w2.xs = this.cl.xj;
    };
    GeographicXYTriangulatingSeriesView.prototype.cs = function () {
        this.cl.w2.xu = this.cl.xl;
    };
    GeographicXYTriangulatingSeriesView.$t = markType(GeographicXYTriangulatingSeriesView, 'GeographicXYTriangulatingSeriesView', HostSeriesView.$);
    return GeographicXYTriangulatingSeriesView;
}(HostSeriesView));
export { GeographicXYTriangulatingSeriesView };
/**
 * @hidden
 */
var GeographicScatterAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicScatterAreaSeriesView, _super);
    function GeographicScatterAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.ct = null;
        _this.ct = a;
        return _this;
    }
    GeographicScatterAreaSeriesView.prototype.ax = function () {
        _super.prototype.ax.call(this);
        if (!this.r) {
        }
    };
    GeographicScatterAreaSeriesView.prototype.b9 = function () {
        _super.prototype.b9.call(this);
        if (this.ct.xw != null) {
            this.ct.xw.y9 = this.ct.x0;
            this.ct.xw.yx = this.ct.xv;
        }
    };
    GeographicScatterAreaSeriesView.prototype.cu = function () {
        if (this.ct.xw != null) {
            this.ct.xw.y9 = this.ct.x0;
        }
    };
    GeographicScatterAreaSeriesView.prototype.cv = function () {
        if (this.ct.xw != null) {
            this.ct.xw.yx = this.ct.xv;
        }
    };
    GeographicScatterAreaSeriesView.$t = markType(GeographicScatterAreaSeriesView, 'GeographicScatterAreaSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicScatterAreaSeriesView;
}(GeographicXYTriangulatingSeriesView));
export { GeographicScatterAreaSeriesView };
/**
 * @hidden
 */
var XamGeographicMapView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamGeographicMapView, _super);
    function XamGeographicMapView(a) {
        var _this = _super.call(this, a) || this;
        _this.fn = null;
        _this.fz = null;
        _this.fx = null;
        _this.fw = null;
        _this.fo = null;
        _this.fp = NaN;
        _this.fz = Rect.empty;
        _this.fn = a;
        _this.fn.u2 = 2;
        _this.fn.iu = 5E-06;
        return _this;
    }
    XamGeographicMapView.prototype.m = function (a) {
        return 2;
    };
    XamGeographicMapView.prototype.bk = function (a) {
        this.j.bw(a);
        this.fn.x0(a);
        this.el();
    };
    XamGeographicMapView.prototype.get_ap = function () {
        return true;
    };
    XamGeographicMapView.prototype.d4 = function () {
        var a;
        var b;
        var c;
        var d;
        var e;
        var f = this.j.a8(a, b, c, d, e);
        a = f.p0;
        b = f.p1;
        c = f.p2;
        d = f.p3;
        e = f.p4;
        this.fx = c;
        this.fo = d;
        this.fw = e;
        var g = this.j.e();
        this.fn.ag = g.a;
        this.fn.aj = g.f;
        this.fn.ah = g.b != null ? g.b : new BrushCollection();
        this.fn.ai = g.c != null ? g.c : new BrushCollection();
        if (this.fn.ah.count == 0) {
            for (var h = 0; h < g.a.count; h++) {
                this.fn.ah.add(g.a.item(h));
            }
        }
        if (g.c.count == 0) {
            for (var i = 0; i < g.f.count; i++) {
                this.fn.ai.add(g.f.item(i));
            }
        }
    };
    XamGeographicMapView.prototype.du = function (a) {
        _super.prototype.du.call(this, a);
        if (this.fn.backgroundContent != null) {
            var b = this.fn.backgroundContent;
            b.be(this.j.ae);
            b.bd(a);
        }
    };
    XamGeographicMapView.prototype.dv = function (a) {
        _super.prototype.dv.call(this, a);
        this.fz = a;
        if (this.fn.backgroundContent != null) {
            var b = this.fn.backgroundContent;
            b.bf(this.fz);
        }
    };
    XamGeographicMapView.prototype.fy = function () {
        return new Rect(0, 0, 0, this.fz.width, this.fz.height);
    };
    XamGeographicMapView.prototype.fs = function () {
        if (this.fn.backgroundContent != null) {
            var a = this.fn.backgroundContent;
            a.a6();
        }
    };
    XamGeographicMapView.prototype.fr = function (a) {
        if (this.fn.w0 != null) {
            this.fn.w0.windowRect = a;
        }
    };
    XamGeographicMapView.prototype.fu = function (a, b) {
        if (this.fn.w0 != null) {
            this.fn.w0.windowRect = this.fn.v5;
        }
        if (a != null) {
            var c = a.ao;
            if (c != null) {
                this.fn.al.h.remove(c.ag);
            }
            a.bd(null);
            a.be(null);
        }
        if (b != null) {
            var d = b.ao;
            if (d != null) {
                this.fn.al.h.add(d.ag);
            }
            if (!this.fz.isEmpty) {
                this.dv(this.fz);
            }
            if (this.w != null) {
                this.du(this.w);
            }
        }
        if (b == null) {
            this.ft(this.w);
        }
    };
    XamGeographicMapView.prototype.ft = function (a) {
        var b = this.fn.hj;
        if (b != 1) {
            a.aa();
            a.ab(b, b);
        }
        a.l(this.fz.left, this.fz.top, this.fz.width, this.fz.height);
        if (b != 1) {
            a.z();
        }
    };
    XamGeographicMapView.prototype.d1 = function () {
        this.fd.ad = Defaults.j;
        this.fe.ad = Defaults.j;
        this.fd._stroke = Defaults.ae;
        this.fe._stroke = Defaults.ae;
        _super.prototype.d1.call(this);
    };
    XamGeographicMapView.prototype.fv = function (a) {
        this.fp = a;
        if (this.fn.backgroundContent != null) {
            this.fn.backgroundContent.bc(a);
        }
    };
    Object.defineProperty(XamGeographicMapView.prototype, "fq", {
        get: function () {
            return this.fp;
        },
        set: function (a) {
            this.fp = a;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMapView.$t = markType(XamGeographicMapView, 'XamGeographicMapView', SeriesViewerView.$);
    return XamGeographicMapView;
}(SeriesViewerView));
export { XamGeographicMapView };
/**
 * @hidden
 */
var OpenStreetMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OpenStreetMapImagery, _super);
    function OpenStreetMapImagery() {
        return _super.call(this, new OpenStreetMapTileSource()) || this;
    }
    Object.defineProperty(OpenStreetMapImagery.prototype, "tilePath", {
        get: function () {
            return this.c(OpenStreetMapImagery.tilePathProperty);
        },
        set: function (a) {
            this.h(OpenStreetMapImagery.tilePathProperty, a);
        },
        enumerable: false,
        configurable: true
    });
    OpenStreetMapImagery.br = function (a, b) {
        a.bq("TilePath", b.oldValue, b.newValue);
    };
    OpenStreetMapImagery.prototype.bq = function (a, b, c) {
        switch (a) {
            case "TilePath":
                this.ap.setTilePathUrl(c == null ? null : c);
                this.aj.e();
                break;
        }
        _super.prototype.ba.call(this, a, b, c);
    };
    OpenStreetMapImagery.$t = markType(OpenStreetMapImagery, 'OpenStreetMapImagery', GeographicMapImagery.$);
    OpenStreetMapImagery.tilePathProperty = DependencyProperty.i("TilePath", String_$type, OpenStreetMapImagery.$, new PropertyMetadata(2, null, OpenStreetMapImagery.br));
    return OpenStreetMapImagery;
}(GeographicMapImagery));
export { OpenStreetMapImagery };
/**
 * @hidden
 */
var GeographicXYTriangulatingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicXYTriangulatingSeries, _super);
    function GeographicXYTriangulatingSeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GeographicXYTriangulatingSeries.prototype.ct = function () {
        return new GeographicXYTriangulatingSeriesView(this);
    };
    GeographicXYTriangulatingSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.xa = a;
    };
    GeographicXYTriangulatingSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.xa.co();
                break;
            case GeographicXYTriangulatingSeries.$$p[1]:
                this.xa.cn();
                break;
            case GeographicXYTriangulatingSeries.$$p[0]:
                this.xa.cm();
                break;
            case GeographicXYTriangulatingSeries.$$p[5]:
                this.xa.cp();
                break;
            case GeographicXYTriangulatingSeries.$$p[2]:
                this.xa.cq();
                break;
            case GeographicXYTriangulatingSeries.$$p[3]:
                this.xa.cr();
                break;
            case GeographicXYTriangulatingSeries.$$p[4]:
                this.xa.cs();
                break;
        }
    };
    GeographicXYTriangulatingSeries.$t = markType(GeographicXYTriangulatingSeries, 'GeographicXYTriangulatingSeries', GeographicMapSeriesHost.$);
    GeographicXYTriangulatingSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicXYTriangulatingSeries, 'raisePropertyChanged', ['LatitudeMemberPath:xc:xn', [2, "pointY"], 'LongitudeMemberPath:xe:xo', [2, "pointX"], 'TriangleVertexMemberPath1:xh:xq', [2, "v1"], 'TriangleVertexMemberPath2:xj:xr', [2, "v2"], 'TriangleVertexMemberPath3:xl:xs', [2, "v3"], 'TrianglesSource:xb:xp', [IEnumerable_$type, null]]);
    return GeographicXYTriangulatingSeries;
}(GeographicMapSeriesHost));
export { GeographicXYTriangulatingSeries };
/**
 * @hidden
 */
var GeographicScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicScatterAreaSeries, _super);
    function GeographicScatterAreaSeries() {
        var _this = _super.call(this) || this;
        _this.xt = null;
        _this.triangulationStatusChanged = null;
        _this.ab = GeographicScatterAreaSeries.$;
        return _this;
    }
    GeographicScatterAreaSeries.prototype.bk = function () {
        return new GeographicScatterAreaSeries();
    };
    GeographicScatterAreaSeries.prototype.get_ev = function () {
        return true;
    };
    Object.defineProperty(GeographicScatterAreaSeries.prototype, "xv", {
        get: function () {
            return this.xt;
        },
        set: function (a) {
            var b = this.xt != a;
            if (b) {
                var c = this.xt;
                if (this.xt != null) {
                    var d = this.xt;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.x3));
                }
                this.xt = a;
                if (this.xt != null) {
                    var e = this.xt;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.x3));
                }
                this.raisePropertyChanged("ColorScale", c, this.xt);
                if (this.xw != null) {
                    this.xw.yx = a;
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicScatterAreaSeries.prototype.x3 = function (a, b) {
        this.xy.cv();
        this.x5();
        this.rs(false);
    };
    GeographicScatterAreaSeries.prototype.x5 = function () {
        if (this.xw != null) {
            this.xu = this.xw.yw;
        }
    };
    GeographicScatterAreaSeries.prototype.sj = function () {
        _super.prototype.sj.call(this);
        this.x5();
    };
    GeographicScatterAreaSeries.prototype.w1 = function () {
        this.xw = new ScatterAreaSeries();
        var a = this.xw;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x4));
        return this.xw;
    };
    GeographicScatterAreaSeries.prototype.x4 = function (a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, b);
        }
    };
    GeographicScatterAreaSeries.prototype.ct = function () {
        return new GeographicScatterAreaSeriesView(this);
    };
    GeographicScatterAreaSeries.prototype.q1 = function (a) {
        _super.prototype.q1.call(this, a);
        this.xy = a;
    };
    GeographicScatterAreaSeries.prototype.ra = function (a, b, c, d) {
        _super.prototype.ra.call(this, a, b, c, d);
        switch (b) {
            case GeographicScatterAreaSeries.$$p[1]:
                this.xy.cu();
                break;
            case "ColorScale":
                this.xy.cv();
                this.x5();
                break;
        }
    };
    GeographicScatterAreaSeries.prototype.get_g7 = function () {
        return true;
    };
    GeographicScatterAreaSeries.prototype.set_g7 = function (a) {
        _super.prototype.set_g7.call(this, a);
    };
    GeographicScatterAreaSeries.$t = markType(GeographicScatterAreaSeries, 'GeographicScatterAreaSeries', GeographicXYTriangulatingSeries.$);
    GeographicScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:xu:x6', [ColorScale.$, null], 'ColorMemberPath:x0:x7', [2, "value"]]);
    return GeographicScatterAreaSeries;
}(GeographicXYTriangulatingSeries));
export { GeographicScatterAreaSeries };
