import { Series } from "igniteui-webcomponents-charts";
import { Point, Type } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { SeriesPointOfInterest } from "igniteui-webcomponents-charts";
import { Axis } from "igniteui-webcomponents-charts";
import { HighlightingInfo } from "igniteui-webcomponents-core";
import { Rect } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { RenderSurface } from "igniteui-webcomponents-charts";
import { DataContext } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare abstract class GeographicMapSeriesHost extends Series {
    static $t: Type;
    qg(): void;
    constructor();
    private w0;
    protected get_fc(): boolean;
    kq(a: any, b: string): any;
    md(a: string): string;
    protected get_ki(): any;
    protected set_ki(a: any): void;
    ec(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    ai(): Axis[];
    bp(): Series;
    get w2(): Series;
    set w2(a: Series);
    protected get_hasMarkers(): boolean;
    protected w7(a: any, b: any): void;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    kn(a: Point): any;
    ka(a: Point, b: boolean): number;
    j8(a: Point, b: boolean): number;
    i5(a: Point, b: boolean, c: boolean): number;
    we(a: Point, b: boolean, c: boolean): Point;
    wp(a: Point): Rect;
    ao(a: Point): Rect[];
    wq(a: Point): Rect;
    ap(a: Point): Rect[];
    wr(a: Point): Rect;
    ws(a: Point): Rect;
    i1(a: Point, b: boolean, c: boolean): number;
    wa(a: Point, b: boolean, c: boolean): Point;
    i3(a: Point, b: boolean, c: boolean): number;
    wc(a: Point, b: boolean, c: boolean): Point;
    wf(a: Point, b: boolean, c: boolean): Point;
    i6(a: Point, b: boolean, c: boolean): number;
    wb(a: Point, b: boolean, c: boolean): Point;
    i2(a: Point, b: boolean, c: boolean): number;
    wd(a: Point, b: boolean, c: boolean): Point;
    i4(a: Point, b: boolean, c: boolean): number;
    j4(a: Point): number;
    iw(): number;
    is(a: Point): number;
    ko(a: Point): any;
    protected abstract w1(): Series;
    protected ct(): SeriesView;
    q1(a: SeriesView): void;
    w3: HostSeriesView;
    static readonly w9: DependencyProperty;
    get w4(): number;
    set w4(a: number);
    protected ra(a: any, b: string, c: any, d: any): void;
    private w6;
    private w8;
    rs(a: boolean): void;
    protected q5(a: boolean): void;
    rr(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    a2(a: Point, b: boolean): DataContext;
    se(): void;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    protected pz(a: any): void;
}
/**
 * @hidden
 */
export declare class HostSeriesView extends SeriesView {
    static $t: Type;
    constructor(a: GeographicMapSeriesHost);
    private b4;
    aw(a: RenderingContext, b: RenderingContext): void;
    b9(): void;
    ca(): void;
    ch(): void;
    ck(): void;
    ce(): void;
    cj(): void;
    b8(): void;
    cg(): void;
    b5(): void;
    b6(): void;
    cb(): void;
    cc(): void;
    b7(): void;
    cd(): void;
    cf(): void;
    ci(): void;
}
