import { ShapeSeriesBase } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler } from "igniteui-webcomponents-core";
import { GeographicMapImagery } from "./GeographicMapImagery";
import { Type, EventArgs } from "igniteui-webcomponents-core";
import { Series } from "igniteui-webcomponents-charts";
import { SeriesView } from "igniteui-webcomponents-charts";
import { Rect } from "igniteui-webcomponents-core";
import { DependencyObject } from "igniteui-webcomponents-core";
import { RenderSurface } from "igniteui-webcomponents-charts";
import { FrameworkElement } from "igniteui-webcomponents-core";
import { ShapeSeriesViewBase } from "igniteui-webcomponents-charts";
import { RenderingContext } from "igniteui-webcomponents-core";
import { PathGeometry } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { PointCollection } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class TileSeries extends ShapeSeriesBase implements IMapRenderDeferralHandler {
    static $t: Type;
    protected bk(): Series;
    protected get_f3(): boolean;
    constructor();
    protected ct(): SeriesView;
    q1(a: SeriesView): void;
    protected get_yc(): boolean;
    protected z9: TileSeriesView;
    get aad(): GeographicMapImagery;
    set aad(a: GeographicMapImagery);
    private aab;
    private aaa;
    protected get aac(): GeographicMapImagery;
    protected set aac(a: GeographicMapImagery);
    protected ra(a: any, b: string, c: any, d: any): void;
    private aai;
    imageTilesReady: (sender: any, e: EventArgs) => void;
    private aaj;
    private aae;
    register(a: DependencyObject, b: (arg1: boolean) => void): void;
    unRegister(a: DependencyObject): void;
    deferredRefresh(): void;
    deferAction(a: () => void): void;
    protected ss(a: Rect, b: Rect): void;
    private aaf;
    rt(a: boolean): void;
    protected aak(a: boolean, b: SeriesView): void;
    rr(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    private aal;
    o5(a: boolean, b: SeriesView): void;
}
/**
 * @hidden
 */
export declare class TileSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: TileSeries);
    protected de: TileSeries;
    ax(): void;
    protected co(a: FrameworkElement, b: PathGeometry): void;
    protected c9(a: number, b: List$1<PointCollection>): PathGeometry;
    protected c8(a: number, b: any): FrameworkElement;
    protected cs(a: FrameworkElement, b: boolean): void;
    cq(a: FrameworkElement, b: any, c: boolean): void;
    private dq;
    cy(): void;
    cx(): void;
    dh(a: Rect): void;
    private dg;
    private df;
    dk(a: GeographicMapImagery, b: GeographicMapImagery): void;
    private dj;
    dl(a: GeographicMapImagery, b: GeographicMapImagery): void;
    dn(): void;
    protected bc(a: RenderingContext, b: boolean): void;
    dm(): void;
    di(): void;
    dp(a: Rect): void;
}
